package org.hiroyukki.bxp.ciji;

import java.io.File;
import java.util.HashSet;

import org.hiroyukki.bxp.config.ConfigReader;

/**
 * ڳʼʱԶѰֵĴʼʫ뵽ϵͳ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class CiJiScanner {
	/**
	 * get all ciji from file system.
	 * 
	 * @return HashSet<String>
	 */
	public static HashSet<String> getCiJiNames() {
		File f = new File("ciji");
		HashSet<String> s = new HashSet<String>();
		if (f.isDirectory()) {
			File[] fs = f.listFiles();
			for (File ff : fs) {
				String fileName = ff.getName();
				if (fileName.endsWith(".ciji")) {
					String splitName = fileName.substring(0,
							fileName.length() - 5);
					s.add(splitName);
				}
			}
		}
		return s;
	}

	/**
	 * Get All shi ji names from files
	 * 
	 * @return HashSet
	 */
	public static HashSet<String> getShiJiNames() {
		File f = new File("ciji");
		HashSet<String> s = new HashSet<String>();
		if (f.isDirectory()) {
			File[] fs = f.listFiles();
			for (File ff : fs) {
				String fileName = ff.getName();
				if (fileName.endsWith(".shiji")) {
					String splitName = fileName.substring(0,
							fileName.length() - 6);
					s.add(splitName);
				}
			}
		}
		return s;
	}

	/**
	 * set the HashSet int ProgramConfig
	 */
	public static void Init() {
		ConfigReader.getInstance().setCiJiSet(getCiJiNames());
		ConfigReader.getInstance().setShiJiSet(getShiJiNames());
	}
}
