package org.hiroyukki.bxp.cipu;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Properties;
import java.util.Vector;

import org.hiroyukki.tools.io.HWriter;

/**
 * תûתɡ
 * 
 * @author hiroyukki
 * @since 1.1
 */
public class CiPaiNameRedirector {

	public static String REDIRECT_FILE = "cipu/redirect.properties";

	public static Properties pro;

	/**
	 * a static block, init the Properties
	 * 
	 * @return Properties
	 */
	static {
		if (pro == null) {
			pro = new Properties();
			try {
				pro.load(new FileReader(REDIRECT_FILE));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * Write properties into file, ready for use it next time.<br>
	 * This methods will be call when application exit.
	 */
	@SuppressWarnings("unchecked")
	public static void writeOutProperties() {
		StringBuilder sb = new StringBuilder();
		Vector<String> v = new Vector(pro.keySet());
		for (String str : v) {
			sb.append(str);
			sb.append("=");
			sb.append(pro.get(str));
			sb.append("\n");
		}
		HWriter.writeToFile(sb.toString(), REDIRECT_FILE);
	}

	/**
	 * get anthor name from ciPaiName
	 * 
	 * @param ciPaiName
	 *            String
	 * @return String
	 */
	public static String getSameCiPaiName(String ciPaiName) {
		return pro.getProperty(ciPaiName);
	}
}
