package org.hiroyukki.bxp.io.cipu;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.io.XMLWriter;
import org.hiroyukki.bxp.cipu.CiPuManager;

import java.io.*;

/**
 * һд׵࣬ûָĸʽһDocumentȻдļ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class CiPuWriter {

	/**
	 * ҪдĴһ׵Elementӷʽ׷ӻǸǣдһ
	 * 
	 * @param ciPaiName
	 *            String
	 * @param elementOfCiPu
	 *            Element
	 * @param addType
	 *            String
	 */
	public static void writeCiPu(String ciPaiName, Element elementOfCiPu,
			String addType) {
		if (addType.equals("add")) {
			if (CiPuManager.hasCiPu(ciPaiName)) {
				addCiPuToFile(ciPaiName, elementOfCiPu);
			} else {
				createNewCiPu(ciPaiName, elementOfCiPu);
			}
		} else if (addType.equals("cover")) {
			createNewCiPu(ciPaiName, elementOfCiPu);
		}
	}

	/**
	 * ݴĴʹ׵ElementһȫµĴļԭ޴׻д׵ûҪ󸲸ǵô˷
	 * 
	 * @param ciPaiName
	 *            String
	 * @param elementOfCiPu
	 *            Element
	 */
	@SuppressWarnings("deprecation")
	public static void createNewCiPu(String ciPaiName, Element elementOfCiPu) {
		Document doc = DocumentHelper.createDocument();
		doc.setXMLEncoding("gb2312");
		doc.addDocType("cipai", null, "cipu.dtd");
		Element rootElement = doc.addElement("cipai");
		rootElement.setAttributeValue("name", ciPaiName);
		rootElement.add(elementOfCiPu);
		try {
			FileWriter fw = new FileWriter("cipu/" + ciPaiName + ".xml");
			XMLWriter output = new XMLWriter(fw);
			output.write(doc);
			output.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		formatXMLEncoding(ciPaiName);
	}

	/**
	 * ݴĴʹ׵Elementԭļ׷һףԭдײûҪ׷ʱô˷
	 * 
	 * @param ciPaiName
	 *            String
	 * @param elementOfCiPu
	 *            Element
	 */
	public static void addCiPuToFile(String ciPaiName, Element elementOfCiPu) {
		Document doc = CiPuReader.getCiPaiDocFromName(ciPaiName);
		Element root = doc.getRootElement();
		root.add(elementOfCiPu);
		try {
			FileWriter fw = new FileWriter("cipu/" + ciPaiName + ".xml");
			XMLWriter output = new XMLWriter(fw);
			output.write(doc);
			output.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		formatXMLEncoding(ciPaiName);
	}

	/**
	 * ʽDocumentıΪgb2312ڴдDocumentıЧʲôļʹ޸ļбؼʵ֡<br />
	 * the method getXMLEncoding() in dom4j API:
	 * <p>
	 * Return the encoding of this document, as part of the XML declaration This
	 * is null when unspecified or when it is not known (<font color="red">such
	 * as when the Document was created in memory</font>) or when the
	 * implementation does not support this operation. The way this encoding is
	 * retrieved also depends on the way the XML source is parsed. For instance,
	 * if the SAXReader is used and if the underlying XMLReader implementation
	 * support the org.xml.sax.ext.Locator2 interface, the result returned by
	 * this method is specified by the getEncoding() method of that interface.
	 * </p>
	 */
	protected static void formatXMLEncoding(String ciPaiName) {
		FileReader fr = null;
		BufferedReader br = null;
		FileWriter fw = null;
		BufferedWriter bw = null;
		String bufferString = null;
		String result = "";
		// ȴַ
		try {
			fr = new FileReader("cipu/" + ciPaiName + ".xml");
			br = new BufferedReader(fr);
			while ((bufferString = br.readLine()) != null) {
				result += bufferString;
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				fr.close();
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		// 滻
		result = result.replace("UTF-8", "gb2312");
		// ʹд
		try {
			fw = new FileWriter("cipu/" + ciPaiName + ".xml");
			bw = new BufferedWriter(fw);
			bw.write(result);
			bw.flush();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				fw.close();
				bw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}

		}
	}
}
