package org.hiroyukki.bxp.poem;

import java.io.FileNotFoundException;

import org.hiroyukki.bxp.yun.CiLinZhengYun;
import org.hiroyukki.bxp.yun.CoreMethods;
import org.hiroyukki.bxp.yun.WordInfo;
import org.hiroyukki.bxp.yun.YunBu;
import org.hiroyukki.bxp.yun.YunDetails;

/**
 * This class provide some useful methods for "ping shui yun", it will parse out
 * ping shui yun from CiLinZhengYun. <br>
 * <br>
 * Already Test successfully.
 * 
 * @see org.hiroyukki.bxp.yun.CiLinZhengYun
 * @author hiroyukki
 * @version 2010.01.06
 * @since 2010
 */
public class PingShuiManager {
	/**
	 * get equal words that have same ping shui yun.
	 * 
	 * @param word
	 * @return String
	 */
	public static String getSamePingShui(String word) {
		return getSamePingShui(CoreMethods.getWordInfo(word, ""));
	}

	/**
	 * because of Controversial words, must certain which yun bu you need be
	 * parse
	 * 
	 * @param wi
	 * @return String
	 */
	public static String getSamePingShui(WordInfo wi) {
		YunBu yb;
		try {
			yb = CiLinZhengYun.getInstance().get(wi.getYunBu());
			YunDetails ps = yb.get(wi.getYunDetails());
			return ps.getContent();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
}
