package org.hiroyukki.bxp.poem;

import java.io.Serializable;
import java.util.List;

import org.hiroyukki.tools.date.DateManager;

/**
 * Instance of this class stand for a poem.<br>
 * In order to save poem to files on disk, we implements java.io.Serializable.<br>
 * We can open poems we write when this application start next time.
 * 
 * @author hiroyukki
 * @since 2010
 * @version 2010.01.05
 */
public class Poem implements Serializable {

	private static final long serialVersionUID = 1L;
	List<ShiJu> list;
	/**
	 * name ָ߾ɡ
	 */
	private String name;
	/**
	 * title ָʫĸ
	 */
	private String title;
	private String author;
	private String date;
	private String type;
	private String remark;

	public Poem() {
		this.date = DateManager.getCurrentTime();
	}

	public List<ShiJu> getList() {
		return list;
	}

	public void setList(List<ShiJu> list) {
		this.list = list;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getAuthor() {
		return author;
	}

	public void setAuthor(String author) {
		this.author = author;
	}

	public String getDate() {
		return date;
	}

	public void setDate(String date) {
		this.date = date;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(name);
		if (title != null && !title.equals("")) {
			sb.append("" + title + "\n");
		}
		sb.append(author + "\n\n");
		int size = list.size();
		for (int i = 0; i < size; i++) {
			sb.append(list.get(i).toString());
			if (i % 2 == 0) {
				sb.append("");
			} else {
				sb.append("\n");
			}
		}
		return sb.toString();
	}
}
