package org.hiroyukki.bxp.poem;

import java.util.ArrayList;
import java.util.List;

import org.hiroyukki.bxp.cipu.CiPu;
import org.hiroyukki.bxp.cipu.HuanYun;
import org.hiroyukki.bxp.cipu.Ju;
import org.hiroyukki.bxp.cipu.Yun;

/**
 * This class stand for model for a poem.<br>
 * We parse ju model from XML file by same way as Ci,<br>
 * after this, change cipu to a poem model.<br>
 * when write poem, we must refrence this model.<br>
 * 
 * @author hiroyukki
 * @version 2010.01.06
 * @since 2010
 */
public class PoemModel {

	private CiPu cp;
	public List<ShiJuModel> shiJuList;
	public String name;
	public String type;

	public PoemModel(CiPu cp) {
		this.cp = cp;
		this.name = cp.getCiPaiName();
		this.type = cp.getType();
		shiJuList = new ArrayList<ShiJuModel>();
		init();
	}

	/**
	 * This method get all ci ju from ci pai and tranlate them to shi ju.
	 */
	private void init() {
		for (HuanYun hy : cp) {
			for (Yun y : hy) {
				for (Ju j : y) {
					shiJuList.add(new ShiJuModel(j));
				}
			}
		}
	}
}
