package org.hiroyukki.bxp.poem;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.hiroyukki.tools.date.DateManager;

/**
 * 
 * @author hiroyukki
 * 
 */
public class ShiJi implements Serializable {

	private static final long serialVersionUID = 1L;

	private String author;
	private String name;
	private List<Poem> poemList;
	private String date;

	public ShiJi() {
		this.date = DateManager.getCurrentTime();
		poemList = new ArrayList<Poem>();
	}

	public String getAuthor() {
		return author;
	}

	public void setAuthor(String author) {
		this.author = author;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List<Poem> getPoemList() {
		return poemList;
	}

	public void setPoemList(List<Poem> poemList) {
		this.poemList = poemList;
	}

	public String getDate() {
		return date;
	}

	public void setDate(String date) {
		this.date = date;
	}

	/**
	 * Insert a poem into shi ji
	 * 
	 * @param p
	 */
	public void add(Poem p) {
		poemList.add(p);
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("" + name + "\n");
		sb.append(author + "\n\n");
		for (Poem p : poemList) {
			sb.append(p.toString() + "\n");
		}
		return sb.toString();
	}
}
