package org.hiroyukki.bxp.poem;

import java.io.Serializable;

import org.hiroyukki.bxp.cipu.Ju;

/**
 * this class stand for a model of shi ju. <br>
 * you must refrence this model when you write poem.<br>
 * after read out ci ju from XML file, this class change ci ju to shi ju
 * 
 * @author hiroyukki
 * @since 2010
 * @version 2010.01.06
 */
public class ShiJuModel implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * һ
	 */
	private String context;

	/**
	 * һϢ
	 */
	private String info;

	/**
	 * һ䳤
	 */
	private int length;

	/**
	 * ־˾ǷҪѺ
	 */
	private boolean isYunJu;

	/**
	 * Translate a ci ju to shi ju
	 * 
	 * @param j
	 */
	public ShiJuModel(Ju j) {
		this.context = j.getContext();
		this.info = j.getInfo();
		this.isYunJu = j.isYunJu();
		this.length = j.getLength();
	}

	public String getContext() {
		return context;
	}

	public void setContext(String context) {
		this.context = context;
	}

	public String getInfo() {
		return info;
	}

	public void setInfo(String info) {
		this.info = info;
	}

	public int getLength() {
		return length;
	}

	public void setLength(int length) {
		this.length = length;
	}

	public boolean isYunJu() {
		return isYunJu;
	}

	public void setYunJu(boolean isYunJu) {
		this.isYunJu = isYunJu;
	}

	/**
	 * õϵƽƣһֵƽƣΪ˵<br>
	 * ֻСƽ͡ơ˵Уֱӷء
	 * 
	 * @return String
	 */
	public String getPingZe() {
		String end = getContext().substring(getLength() - 1, getLength());
		return end;
	}
}
