package org.hiroyukki.bxp.socket.message;

import java.io.Serializable;
import java.util.Date;

import org.hiroyukki.bxp.config.ConfigReader;

/**
 * before send , chat message must packaged be instance of this class. when this
 * instance sent to client, client will parse it and show it on compoment
 * 
 * @author hiroyukki
 * @since 1.2
 */
public class ChatMessage implements Serializable {

	private static final long serialVersionUID = 1L;

	public ChatMessage() {
		if (ConfigReader.getInstance().getUserName() != null) {
			setFromName(ConfigReader.getInstance().getUserName());
		} else {
			setFromName("δ");
		}
	}

	/**
	 * default name of the from ip
	 */
	private String fromName;

	/**
	 * where this message come from
	 */
	private String fromIP;

	/**
	 * where this message will send to
	 */
	private String toIP;

	/**
	 * when this message send
	 */
	private Date time;

	/**
	 * content of the message
	 */
	private String content;

	public String getFromIP() {
		return fromIP;
	}

	public void setFromIP(String fromIP) {
		this.fromIP = fromIP;
	}

	public String getToIP() {
		return toIP;
	}

	public void setToIP(String toIP) {
		this.toIP = toIP;
	}

	public Date getTime() {
		return time;
	}

	public void setTime(Date time) {
		this.time = time;
	}

	public String getContent() {
		return content;
	}

	public void setContent(String content) {
		this.content = content;
	}

	public String getFromName() {
		return fromName;
	}

	public void setFromName(String fromName) {
		this.fromName = fromName;
	}

	@SuppressWarnings("deprecation")
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(getTime().toLocaleString());
		sb.append(" ");
		sb.append(getFromName());
		sb.append("\n");
		sb.append(getContent());
		sb.append("\n");
		return sb.toString();
	}
}
