package org.hiroyukki.bxp.ui.ciji;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

import org.hiroyukki.bxp.ciji.Ci;
import org.hiroyukki.bxp.ciji.CiJiManager;
import org.hiroyukki.bxp.ui.cipu.CiEditPanel;
import org.hiroyukki.bxp.ui.cipu.CiPuPanel;
import org.hiroyukki.bxp.ui.main.MainFrame;
import org.hiroyukki.bxp.ui.main.MainMenuBar;

/**
 * ʹʵ壬һ״ʺݴʵĴƣ͵Ϣһ壬ٰѴ뵽
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class AdmireCiPanel extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	/**
	 * AdmireCiPanel must contain a CiPuPanel
	 */
	CiPuPanel cpp;
	/**
	 * target Ci
	 */
	Ci c;

	private JPanel ciInfoPanel = new JPanel();
	private JPanel centerPanel = new JPanel();
	private JPanel buttonPanel = new JPanel();
	private JButton ciYunButton = new JButton("");
	private JButton shutButton = new JButton("رմ");
	private JButton editButton = new JButton("˸");

	public AdmireCiPanel(Ci c) {
		this.c = c;
		initPanel();
	}

	/**
	 * init this panel
	 */
	public void initPanel() {
		editButton.addActionListener(this);
		shutButton.addActionListener(this);
		ciYunButton.addActionListener(this);

		cpp = new CiPuPanel(c);
		centerPanel.setLayout(new BorderLayout());
		centerPanel.add(cpp.jsp, BorderLayout.CENTER);
		setLayout(new BorderLayout());
		buttonPanel.add(editButton);
		buttonPanel.add(ciYunButton);
		buttonPanel.add(shutButton);
		ciInfoPanel.setLayout(new GridLayout(1, 3, 5, 5));
		ciInfoPanel.add(new JLabel("ߣ" + c.getAuthor()));
		if (c.getTitle() != null && !c.getTitle().equals("")) {
			ciInfoPanel.add(new JLabel("⣺" + c.getTitle()));
		}
		if (c.getType() != null && !c.getType().equals("")) {
			ciInfoPanel.add(new JLabel("ʸ" + c.getType()));
		}
		ciInfoPanel.setBorder(new TitledBorder("йϢ"));
		buttonPanel.setBorder(new TitledBorder(""));
		add(ciInfoPanel, BorderLayout.NORTH);
		add(centerPanel, BorderLayout.CENTER);
		add(buttonPanel, BorderLayout.SOUTH);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == ciYunButton) {
			// CiYunPanel cyp = new CiYunPanel(c);
			CiEditPanel cep = new CiEditPanel(c);
			MainMenuBar.getInstance().handlePanel(cep);
		} else if (e.getSource() == shutButton) {
			MainFrame.getInstance().center.remove(CiJiPanel.getInstance());
		} else if (e.getSource() == editButton) {
			CiEditPanel cep = new CiEditPanel(CiJiManager.getCiPuFromCi(c),
					MainMenuBar.getInstance().getYunType());
			MainMenuBar.getInstance().handlePanel(cep);
		}
	}
}
