package org.hiroyukki.bxp.ui.ciji;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.hiroyukki.bxp.ciji.CiJiManager;
import org.hiroyukki.bxp.config.ConfigReader;
import org.hiroyukki.bxp.io.poem.ShiJiManager;
import org.hiroyukki.bxp.ui.poem.ShiJiPanel;
import org.hiroyukki.tools.ui.img.ImageLoader;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextField;

/**
 * this Class is used be create new ci ji and shi ji.<br>
 * This class is singleton.
 * 
 * @author hiroyukki
 * @since 2010
 * @version 2010.01.06
 */
public class CreateJiFrame extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;

	public static String SJ = "ʫ";
	public static String CJ = "ʼ";

	public static CreateJiFrame instance;
	private static Integer I = 1;
	private String createType;

	public static CreateJiFrame getInstance() {
		if (instance == null) {
			synchronized (I) {
				if (instance == null) {
					instance = new CreateJiFrame();
				}
			}
		}
		return instance;
	}

	private JButton okButton = new JButton("ȷ");
	private JButton clearButton = new JButton("");
	private JButton cancelButton = new JButton("ȡ");
	private JPanel namePanel = new JPanel();
	private JPanel authorPanel = new JPanel();
	private JPanel buttonPanel = new JPanel();
	private HTextField nameField = new HTextField(8);
	private HTextField authorField = new HTextField(8);

	private CreateJiFrame() {
		namePanel.add(new JLabel("ļ֣"));
		namePanel.add(nameField);

		authorPanel.add(new JLabel("ļߣ"));
		authorPanel.add(authorField);

		okButton.addActionListener(this);
		clearButton.addActionListener(this);
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(clearButton);
		buttonPanel.add(cancelButton);

		setModal(true);
		setTitle("ļ");
		setIconImage(ImageLoader.getImage("logo.png"));
		setSize(200, 150);
		setLayout(new GridLayout(3, 1, 0, 0));
		setResizable(false);
		add(namePanel);
		add(authorPanel);
		add(buttonPanel);
		ComponentManager.moveToCenter(this);
	}

	public void clear() {
		nameField.setText("");
		authorField.setText(ConfigReader.getInstance().getUserName());
	}

	private void create() {
		if (createType == null) {
			ComponentManager.msgBox("Ҫļ");
			return;
		}
		String name = nameField.getText();
		String author = authorField.getText();
		if (name.equals("") || name == null || author.equals("")
				|| author == null) {
			ComponentManager.msgBox("ļ߲Ϊ");
			return;
		}
		if (createType.equals(CJ)) {
			CiJiManager.createNewCiJi(name, author);
			CiJiPanel.getInstance().addCiJiNameIntoList(name);
		} else if (createType.equals(SJ)) {
			ShiJiManager.createShiJi(name, author);
			ShiJiPanel.getInstance().addShiJiNmeIntoList(name);
		}
		setVisible(false);
		ComponentManager.msgBox("ɹ");
	}

	public void cancel() {
		clear();
		setVisible(false);
	}

	public String getCreateType() {
		return createType;
	}

	public void setCreateType(String createType) {
		this.createType = createType;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == okButton) {
			create();
		} else if (e.getSource() == clearButton) {
			clear();
		} else if (e.getSource() == cancelButton) {
			cancel();
		}
	}
}
