package org.hiroyukki.bxp.ui.ciji;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JWindow;

import org.hiroyukki.bxp.desktop.DesktopManager;
import org.hiroyukki.tools.date.DateManager;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextArea;

/**
 * ʾһʼݡ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class ShowContentWindow extends JWindow implements ActionListener {

	private static final long serialVersionUID = 1L;

	public static ShowContentWindow instance;

	public static ShowContentWindow getInstance() {
		if (instance == null) {
			instance = new ShowContentWindow();
		}
		return instance;
	}

	private JPanel topPanel = new JPanel();
	private JPanel buttonPanel = new JPanel();
	public HTextArea jta = new HTextArea();
	private JButton closeButton = new JButton("ر");
	private JButton copyButton = new JButton("");
	private JButton sendButton = new JButton("δʰ");

	public ShowContentWindow() {
		sendButton.addActionListener(this);
		closeButton.addActionListener(this);
		copyButton.addActionListener(this);
		jta.setEditable(false);
		topPanel.setLayout(new BorderLayout());
		topPanel.add(new JScrollPane(jta));
		buttonPanel.add(copyButton);
		buttonPanel.add(sendButton);
		buttonPanel.add(closeButton);
		setLayout(new BorderLayout());
		add(topPanel, BorderLayout.CENTER);
		add(buttonPanel, BorderLayout.SOUTH);
		setSize(500, 400);
		ComponentManager.moveToCenter(this);
	}

	/**
	 * show text in area
	 * 
	 * @param content
	 *            String
	 */
	public void showContent(String content) {
		jta.setText(content);
		jta.append("\nΪ2010Ϊ\n");
		jta.append("            --" + DateManager.getCurrentTime());
		setVisible(true);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == copyButton) {
			jta.selectAll();
			jta.copy();
			setVisible(false);
			ComponentManager.msgBox("ѸƵ壬ճĴˡ");
		} else if (e.getSource() == closeButton) {
			setVisible(false);
		} else if (e.getSource() == sendButton) {
			jta.selectAll();
			jta.copy();
			DesktopManager
					.browse("http://tieba.baidu.com/f?ct=&tn=&rn=&pn=&lm=&cm=0"
							+ "&kw=%CB%CE%B4%CA&rs2=0&sc=&un=&rs1=&rs5=&sn=&rs6=&myselectvalue=0&word=%CB%CE%B4%CA&tb=on");
		}
	}
}
