package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.border.TitledBorder;

import org.hiroyukki.bxp.ciji.Ci;
import org.hiroyukki.bxp.ciji.CiJi;
import org.hiroyukki.bxp.ciji.CiJiManager;
import org.hiroyukki.bxp.cipu.CiPu;
import org.hiroyukki.bxp.config.ConfigReader;
import org.hiroyukki.bxp.ui.ciji.CiJiPanel;
import org.hiroyukki.bxp.ui.main.MainMenuBar;
import org.hiroyukki.bxp.ui.main.MainPanel;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextArea;
import org.hiroyukki.tools.ui.HTextField;

/**
 * һ༭ʵ壬еĺһ塣
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class CiEditPanel extends JPanel implements ActionListener, MainPanel {

	private static final long serialVersionUID = 1L;
	/**
	 * ־ǷѾˣûظ
	 */
	private boolean isSaved = false;
	private String componentName;

	private String yunType;
	private JSplitPane center = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
	private JSplitPane topCenter = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
	private JPanel topPanel = new JPanel();
	private JPanel leftPanel = new JPanel();
	private JPanel bottomPanel = new JPanel();
	private JButton clearButton = new JButton("");
	private JButton saveButton = new JButton("浽ʼ");
	private JButton checkButton = new JButton("ɷ");
	private HTextField ciPaiField = new HTextField();
	private HTextField titleField = new HTextField();
	private HTextField authorField = new HTextField();
	private JComboBox ciJiList;
	private JPanel buttonPanel = new JPanel();
	public HTextArea jta = new HTextArea();
	private CiPuPanel cpp;
	private CiPu cp;
	/**
	 * ô
	 */
	private Ci c;

	private boolean canClose = false;

	protected CiEditPanel() {

	}

	/**
	 * ͨ༭
	 * 
	 * @param cp
	 *            CiPai
	 * @param yunType
	 *            String
	 */
	public CiEditPanel(CiPu cp, String yunType) {
		setComponentName("");
		this.cp = cp;
		this.yunType = yunType;
		cpp = new CiPuPanel(this, cp, getYunType());
		ciPaiField.setText(cp.getCiPaiName());
		init();
	}

	/**
	 * һ״Ϊģ崴
	 * 
	 * @param c
	 *            Ci
	 */
	public CiEditPanel(Ci c) {
		this.c = c;
		setComponentName("");
		ciPaiField.setText(c.getCiPaiName());
		cpp = new CiPuPanel(this, c);
		cpp.changeToCiYunPanel();
		init();
	}

	/**
	 * ʼϢơ
	 */
	public void init() {

		setLayout(new BorderLayout());
		jta.setEditable(false);
		jta.setLineWrap(true);
		jta.setBorder(new TitledBorder(""));

		leftPanel.setLayout(new GridLayout(8, 1, 5, 5));
		ciPaiField.setEditable(false);
		if (ConfigReader.getInstance().getUserName() != null) {
			authorField.setText(ConfigReader.getInstance().getUserName());
		}
		Vector<String> v = new Vector<String>(ConfigReader.getInstance()
				.getCiJiSet());
		ciJiList = new JComboBox(v);
		// ĬϴʼղҵĬϴʼʱűѡĬϴʼ
		if (ConfigReader.getInstance().getDefaultCiJiName() != null) {
			if (v.contains(ConfigReader.getInstance().getDefaultCiJiName())) {
				ciJiList.setSelectedItem(ConfigReader.getInstance()
						.getDefaultCiJiName());
			}
		}

		leftPanel.setBorder(new TitledBorder("Ϣ"));
		leftPanel.add(new JLabel(":"));
		leftPanel.add(ciPaiField);
		leftPanel.add(new JLabel("⣺"));
		leftPanel.add(titleField);
		leftPanel.add(new JLabel(""));
		leftPanel.add(authorField);
		leftPanel.add(new JLabel("浽ʼ"));
		leftPanel.add(ciJiList);

		topPanel.setLayout(new BorderLayout());
		topCenter.setLeftComponent(new JScrollPane(leftPanel));
		topCenter.setRightComponent(cpp.jsp);
		topPanel.add(topCenter, BorderLayout.CENTER);
		topCenter.setResizeWeight(0);
		topCenter.setDividerLocation(150);

		bottomPanel.setLayout(new BorderLayout());
		bottomPanel.add(new JScrollPane(jta), BorderLayout.CENTER);
		saveButton.addActionListener(this);
		checkButton.addActionListener(this);
		clearButton.addActionListener(this);
		buttonPanel.add(clearButton);
		buttonPanel.add(saveButton);
		buttonPanel.add(checkButton);
		bottomPanel.add(buttonPanel, BorderLayout.SOUTH);

		center.setDividerSize(15);
		center.setResizeWeight(1);
		center.setOneTouchExpandable(true);
		center.setLeftComponent(topPanel);
		center.setBottomComponent(bottomPanel);
		center.setDividerLocation(320);
		add(center, BorderLayout.CENTER);
	}

	/**
	 * 
	 */
	public void destroy() {
		try {
			this.finalize();
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}

	/**
	 * Ϣеóʵʵ
	 * 
	 * @return Ci
	 */
	public Ci getCiFromUIComponent() {
		String ciPaiName = "";
		String type = "";
		if (cp != null) {
			ciPaiName = cp.getCiPaiName();
			type = cp.getType();
		} else {
			ciPaiName = c.getCiPaiName();
			type = c.getType();
		}
		Ci c = new Ci();
		c.setAuthor(authorField.getText());
		c.setCiPaiName(ciPaiName);
		c.setTitle(titleField.getText());
		c.setType(type);
		c.setYunType(yunType);
		c.setContent(cpp.getCiContent());
		return c;
	}

	/**
	 * 
	 */
	public void clear() {
		int i = JOptionPane.showConfirmDialog(null, "ȷҪ?");
		if (i == JOptionPane.YES_OPTION) {
			cpp.clear();
		}
	}

	/**
	 * ɵĴдʼ
	 */
	public void addCiIntoCiJi() {
		if (isSaved == false) {
			if (ConfigReader.getInstance().getCiJiSet().size() == 0) {
				ComponentManager.msgBox("㻹ûдʼ½һʼ");
				CiJiPanel cjp = CiJiPanel.getInstance();
				MainMenuBar.getInstance().handlePanel(cjp);
			} else {
				String ciJiName = (String) ciJiList.getSelectedItem();
				CiJi cj = CiJiManager.getCiJiFromName(ciJiName);
				CiJiManager.addNewCi(cj, getCiFromUIComponent());
			}
			ComponentManager.msgBox("ɹ");
			setCanClose(true);
			isSaved = true;
		} else {
			int i = JOptionPane.showConfirmDialog(null,
					"˴Ѿˣ㻹ʼ\nȷٽһ");
			if (i == JOptionPane.YES_OPTION) {
				isSaved = false;
			}
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == saveButton) {
			cpp.checkContent();
			cpp.checkChuLvWords();
			if (cpp.canSave) {
				addCiIntoCiJi();
			} else {
				int i = JOptionPane.showConfirmDialog(null,
						"ʲгϣ鱣棬ִҪ?");
				if (i == JOptionPane.YES_OPTION) {
					addCiIntoCiJi();
				}
			}
		} else if (e.getSource() == checkButton) {
			cpp.checkContent();
			cpp.checkChuLvWords();
		} else if (e.getSource() == clearButton) {
			clear();
		}
	}

	@Override
	public boolean canClose() {
		return isCanClose();
	}

	@Override
	public String getPanelName() {
		return getComponentName();
	}

	public boolean isCanClose() {
		return canClose;
	}

	public void setCanClose(boolean canClose) {
		this.canClose = canClose;
	}

	public String getYunType() {
		return yunType;
	}

	public void setYunType(String yunType) {
		this.yunType = yunType;
	}

	public String getComponentName() {
		return componentName;
	}

	public void setComponentName(String componentName) {
		this.componentName = componentName;
	}
}
