package org.hiroyukki.bxp.ui.cipu;

import java.awt.GridLayout;
import java.util.ArrayList;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.TitledBorder;

import org.hiroyukki.bxp.ciji.Ci;
import org.hiroyukki.bxp.ciji.CiJiManager;
import org.hiroyukki.bxp.ciji.CiParseErrorException;
import org.hiroyukki.bxp.cipu.CiPu;
import org.hiroyukki.bxp.cipu.HuanYun;

/**
 * һ׹壬ͨѧϰͬĴ׻Ʋͬ塣
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class CiPuPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	/**
	 * ϲҪ
	 */
	private boolean needCheckChuYun = true;
	/**
	 * һоһб
	 */
	ArrayList<JuPanel> list;

	/**
	 * 뵽һϡ
	 */
	public JScrollPane jsp;
	/**
	 * ͣϻл
	 */
	private String yunType;
	/**
	 * õһľĸʼʱʹ
	 */
	private int jus;
	/**
	 * һ״гֵĸ
	 */
	public int numOfChuLvWords;
	/**
	 * һ״ֵĸͳУԲ鿴ʡ
	 */
	public int numOfAllWords;
	/**
	 * ־Ƿɱ棬ûκγϣֵΪ档
	 */
	public boolean canSave = true;
	/**
	 * ָʾΪĸʱ༭幹죬һֱ͵壬ʹõʱ༭á
	 */
	public CiEditPanel cep;

	CiPu cp = null;

	protected CiPuPanel() {

	}

	/**
	 * ݲͬͼϻϺһʵ챾ʵ
	 * 
	 * @param cep
	 *            CiEditPanel
	 * @param cp
	 *            CiPu
	 * @param yunType
	 *            String
	 */
	public CiPuPanel(CiEditPanel cep, CiPu cp, String yunType) {
		this.cep = cep;
		this.cp = cp;
		this.setBorder(new TitledBorder("--" + cp.getCiPaiName()));
		this.setYunType(yunType);
		this.setJus(cp.getJus());
		initCiPuPanel();
		jsp = new JScrollPane(this);
	}

	/**
	 * һ״ʴһʹ
	 * 
	 * @param c
	 *            Ci
	 */
	public CiPuPanel(Ci c) {
		this.cp = CiJiManager.getCiPuFromCi(c);
		this.setBorder(new TitledBorder("ʹ--" + c.getCiPaiName()));
		this.setYunType(c.getYunType());
		this.setJus(cp.getJus());
		initCiPuPanel();
		jsp = new JScrollPane(this);
		String content = c.getContent().replace("\n", "");
		ArrayList<String> allJus = new ArrayList<String>();
		String[] contentJus = content.split("");
		for (String str : contentJus) {
			String[] strs = str.split("");
			for (String s : strs) {
				allJus.add(s);
			}
		}
		if (allJus.size() != getAllJus().size()) {
			throw new CiParseErrorException("ʽʧ");
		} else {
			int size = allJus.size();
			for (int i = 0; i < size; i++) {
				getAllJus().get(i).jtf.setText(allJus.get(i));
			}
		}
		lockInput();
	}

	/**
	 * ָʱ༭ʹʹ塣
	 * 
	 * @param cep
	 *            CiEditPanel
	 * @param c
	 *            Ci
	 */
	public CiPuPanel(CiEditPanel cep, Ci c) {
		needCheckChuYun = false;
		this.cep = cep;
		this.cp = CiJiManager.getCiPuFromCi(c);
		this.setBorder(new TitledBorder("--" + c.getCiPaiName()));
		this.setYunType(c.getYunType());
		this.setJus(cp.getJus());
		initCiPuPanel();
		jsp = new JScrollPane(this);
		String content = c.getContent().replace("\n", "");
		ArrayList<String> allJus = new ArrayList<String>();
		String[] contentJus = content.split("");
		for (String str : contentJus) {
			String[] strs = str.split("");
			for (String s : strs) {
				allJus.add(s);
			}
		}
		if (allJus.size() != getAllJus().size()) {
			throw new CiParseErrorException("ʽʧ");
		} else {
			int size = allJus.size();
			for (int i = 0; i < size; i++) {
				getAllJus().get(i).jtf.setText(allJus.get(i));
			}
		}
		lockInput();
	}

	/**
	 * תɴ
	 */
	public void changeToCiYunPanel() {
		for (JuPanel jp : getAllJus()) {
			jp.changeToCiYunJuPanel();
		}
	}

	/**
	 * ôĴ׳ʼʵÿĻʵʼһ岢ӵʵϡ
	 */
	protected void initCiPuPanel() {
		this.setLayout(new GridLayout(getJus(), 1, 5, 5));
		for (JuPanel jp : getAllJus()) {
			this.add(jp);
		}
	}

	/**
	 * õо壬һεô˷ʱʼ
	 * 
	 * @return ArrayList<JuPanel>
	 */
	public ArrayList<JuPanel> getAllJus() {
		if (list == null) {
			list = new ArrayList<JuPanel>();
			for (HuanYun hy : cp) {
				list
						.addAll(new HuanYunPanel(cep, hy, getYunType())
								.getAllJus());
			}
		}
		return list;
	}

	/**
	 * ʵĳʼ飬
	 */
	public void checkChuLvWords() {

		int flagChuLv = 0;
		int flagAll = 0;
		canSave = true;
		for (JuPanel jp : getAllJus()) {
			canSave = canSave && jp.canSave;
			flagAll += jp.getLength();
			flagChuLv += jp.getNumOfChuLvWords();
		}
		StringBuilder sb = new StringBuilder();
		double d = (float) flagChuLv / (float) flagAll * 100;
		sb.append("˴" + flagAll + "\n");
		sb.append("" + flagChuLv + "\n");
		sb.append("ʣ" + d + "%\n");
		if (!canSave) {
			if (!needCheckChuYun) {
				sb.append("ϴʽгϼ飬ĬϵĴǺɵġ\n");
				sb.append("ϵĴȫɵģֻ뿴ܷеĳԼ֤ÿһԡ\n");
				sb.append("ʱֲҪʾȷĴʺɣ뱣档");
			} else {
				sb.append("гʲ齫˴ʱ浽˴ʼ");
			}
		}
		cep.jta.setText(sb.toString());
	}

	/**
	 * 
	 */
	public void clear() {
		for (JuPanel jp : getAllJus()) {
			jp.clear();
		}
		checkContent();
	}

	/**
	 * һԼо
	 */
	public void checkContent() {
		for (JuPanel jp : getAllJus()) {
			jp.checkContent();
		}
	}

	/**
	 * make all JTextField can not be edite, we need this method when open a ci.
	 */
	public void lockInput() {
		for (JuPanel jp : getAllJus()) {
			jp.lockInput();
		}
	}

	/**
	 * еõһ״ʵ
	 * 
	 * @return String
	 */
	public String getCiContent() {
		StringBuilder sb = new StringBuilder();
		for (JuPanel jp : getAllJus()) {
			sb.append(jp.getCiJu());
		}
		return sb.toString();
	}

	/**
	 * õϻ
	 * 
	 * @return String
	 */
	public String getYunType() {
		return yunType;
	}

	/**
	 * ϻ
	 * 
	 * @param yunType
	 *            String
	 */
	public void setYunType(String yunType) {
		this.yunType = yunType;
	}

	/**
	 * õһ׹پ
	 * 
	 * @return int
	 */
	public int getJus() {
		return jus;
	}

	/**
	 * һжپ
	 * 
	 * @param jus
	 *            int
	 */
	public void setJus(int jus) {
		this.jus = jus;
	}

	/**
	 * õָ
	 * 
	 * @return int
	 */
	public int getNumOfChuLvWords() {
		return numOfChuLvWords;
	}

	/**
	 * óָ
	 * 
	 * @param numOfChuLvWords
	 *            int
	 */
	public void setNumOfChuLvWords(int numOfChuLvWords) {
		this.numOfChuLvWords = numOfChuLvWords;
	}

	/**
	 * õһ״ʵ
	 * 
	 * @return int
	 */
	public int getNumOfAllWords() {
		return numOfAllWords;
	}

	/**
	 * һ״ʵĸ
	 * 
	 * @param numOfAllWords
	 *            int
	 */
	public void setNumOfAllWords(int numOfAllWords) {
		this.numOfAllWords = numOfAllWords;
	}

}
