package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.util.ArrayList;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.hiroyukki.bxp.cipu.Ju;
import org.hiroyukki.bxp.cipu.UnknownYaYunTypeException;
import org.hiroyukki.bxp.yun.CoreMethods;
import org.hiroyukki.bxp.yun.NotWordException;
import org.hiroyukki.bxp.yun.WordInfo;
import org.hiroyukki.bxp.yun.WordParserErrorException;
import org.hiroyukki.bxp.yun.YunDetails;
import org.hiroyukki.bxp.yun.YunModel;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextField;

/**
 * һʵʼһ壬һľԵͶϢ
 * <p>
 * ˼ɵĴ󲿷ַҪгϳɼ顣
 * </p>
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class JuPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private JPanel jtfPanel = new JPanel();
	private JLabel infoLabel = new JLabel();
	/**
	 * ֶҪⲿãΪpublic
	 */
	public HTextField jtf;

	/**
	 * ʱһ
	 */
	public HTextField yunJiaoWordField = new HTextField(2);

	/**
	 * ɵº
	 */
	private int numOfChuLvWords = 0;

	/**
	 * һĳ
	 */
	private int length;
	/**
	 * ƽ
	 */
	private String content;
	/**
	 * ͣϻ
	 */
	private String yunType;
	/**
	 * ˾ĶϢ
	 */
	private String info;
	/**
	 * ָʾ˾Ϊĸ幹ģͨм崫ģĿΪʹӦĻЭ
	 */
	public HuanYunPanel hyp;
	/**
	 * ϸ༴崫룬ΪʹһϵѺͣѺЭ
	 */
	private YunPanel yp;

	/**
	 * һǷϵı־λһ״κһϣ˴ʲܱ
	 */
	public boolean canSave = false;

	/**
	 * ϸбֻеһϾʱŻõֶΣֶθ˵ǰпõ
	 */
	public ArrayList<YunDetails> useableWordsList;
	/**
	 * ָʾΪĸʱ༭幹죬һֱ͵壬ʹõʱ༭á
	 */
	public CiEditPanel cep;
	/**
	 * ǷϾ
	 */
	private boolean isYunJu;
	/**
	 * ǷҪϼ飬ǴϣҪ
	 */
	public boolean needCheckChuYun = true;;

	Ju j;

	protected JuPanel() {

	}

	/**
	 * һʵͼϻϹ챾
	 * 
	 * @param j
	 *            Ju
	 * @param yunType
	 *            String
	 */
	public JuPanel(CiEditPanel cep, HuanYunPanel hyp, YunPanel yp, Ju j,
			String yunType) {
		this.cep = cep;
		this.yp = yp;
		this.hyp = hyp;
		this.j = j;
		this.isYunJu = j.isYunJu();
		setYunType(yunType);
		initJuPanel();
	}

	/**
	 * һʵʼ
	 */
	public void initJuPanel() {

		this.setContent(j.getContext());
		int length = content.length();
		this.setLength(length);
		String infoString = (j.getInfo() == null) ? "" : j.getInfo();
		this.setInfo(infoString + "ɣ" + getContent());
		this.setLayout(new GridLayout(1, 2, 5, 5));
		infoLabel.setText(info);
		jtf = new HTextField(length);
		jtf.addFocusListener(new FocusListener() {

			@Override
			public void focusGained(FocusEvent e) {
				if (j.isYunJu()) {
					if (hyp.getYunModel() != null) {
						StringBuilder sb = new StringBuilder();
						sb.append("֣\n");
						for (YunDetails yd : getUseableWordsList()) {
							sb.append(yd.getName() + "  " + yd.getContent()
									+ "\n");
						}
						if (cep != null) {
							cep.jta.setText(sb.toString());
						}
					}
				}
			}

			@Override
			public void focusLost(FocusEvent e) {
				checkContent();
			}

		});
		jtf.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if (j.isYunJu()) {
					String str = JOptionPane
							.showInputDialog("Ҫõ", "");
					setYunModel(str);
				}
			}
		});
		this.add(infoLabel);
		jtfPanel.setLayout(new BorderLayout());
		jtfPanel.add(jtf, BorderLayout.CENTER);
		this.add(jtfPanel);
	}

	/**
	 * תɴϾ
	 */
	public void changeToCiYunJuPanel() {
		jtf.setEditable(true);
		if (isYunJu) {
			yunJiaoWordField.setText(getLastWord());
			yunJiaoWordField.setEditable(false);
			length--;
			jtfPanel.add(yunJiaoWordField, BorderLayout.EAST);
			needCheckChuYun = false;
		}
		clear();
	}

	/**
	 * ݼ飬ȱϴ׳ȡȺϸøɼ
	 */
	public void checkContent() {
		String text = jtf.getText();
		// Ϊգֱӷ
		if (text.trim().length() == 0 || text == null) {
			jtf.setText("");
			return;
		}
		if (text.length() != getLength()) {
			setInfo("˾䳤ȲϹ޷иɼ");
			canSave = false;
			infoLabel.setText(getInfo());
			return;
		} else {
			// Ⱥϸʼ
			checkGeLv();
			// ˾ϾĻҪ
			if (j.isYunJu()) {
				checkYun();
			}
		}
		infoLabel.setText(getInfo());
	}

	/**
	 * ɡʱĸףпܰɽֿ֣ûд֣ƽ֡֡
	 * ֻе˾źɣʾ
	 * 
	 */
	public void checkGeLv() {
		if (!j.isYunJu()) {
			// Ͼ䣬ɶԱ
			canSave = true;
		}
		// ɵ
		StringBuilder chuLvWords = new StringBuilder();
		// ƽ
		StringBuilder controversialWords = new StringBuilder();
		// δܽ
		StringBuilder canNotParserWords = new StringBuilder();
		StringBuilder infoString = new StringBuilder();
		int length = getLength();
		for (int i = 0; i < length; i++) {
			// ޶ΪУɼ飬һѭ
			if (getContent().substring(i, i + 1).equals("")) {
				continue;
			}
			String word = jtf.getText().substring(i, i + 1);
			// һƽ֣򲻼ɣһʾ
			try {
				if (CoreMethods.isPingZeControversialWord(word, getYunType())) {
					controversialWords.append(word);
				} else {
					// һֵƽƺʹƽƲͬо档
					if (!CoreMethods.getPingZe(word, getYunType()).equals(
							getContent().substring(i, i + 1))) {
						chuLvWords.append(word);
						jtf.setBackground(Color.RED);
					}
				}
			} catch (WordParserErrorException e) {
				canNotParserWords.append(word);
			}
		}
		// ᵽָ
		setNumOfChuLvWords(chuLvWords.length());
		if (chuLvWords.length() != 0) {
			infoString.append("֣" + chuLvWords + "");
		}
		if (controversialWords.length() != 0) {
			infoString.append("֣" + controversialWords + "");
		}
		if (canNotParserWords.length() != 0) {
			infoString.append("֣ܽ" + canNotParserWords + "");
		}
		if (infoString.length() != 0) {
			setInfo(infoString.toString());
		} else {
			jtf.setBackground(Color.WHITE);
			setInfo("˾ɡ");
		}
		if (chuLvWords.length() == 0 && controversialWords.length() != 0) {
			jtf.setBackground(new Color(250, 150, 0));
		}
		if (chuLvWords.length() == 0 && canNotParserWords.length() != 0) {
			jtf.setBackground(new Color(255, 255, 0));
		}
	}

	/**
	 * ϣȻڱľϾʱŻô˷δģ壬һΪĬģ塣 ã
	 * ͶӦģУԽгϼ⡣
	 */
	public void checkYun() {
		if (needCheckChuYun) {
			String lastWord = jtf.getText().substring(length - 1, length);
			if (hyp.getYunModel() == null) {
				// һԴΪģģ
				setYunModel(lastWord);
				// System.out.println(hyp.getYunModel());
			} else {
				// ǵһεĻ˵Ѿ壬ڵ֮УжǷɡ
				try {
					checkYun(lastWord);
				} catch (WordParserErrorException e) {

				}
			}
		}
	}

	/**
	 * һΪУǷɣֱַ֣У飬ѰǷƥ¼УԶΪƥ䣬ɡ
	 * ȻҪѺΪѺЭвͬļⷽʽ
	 * 
	 * @param word
	 *            String
	 * @return boolean
	 */
	public boolean checkYun(String word) throws WordParserErrorException {
		// õѺѺЭ
		String yaYunType = yp.getYaYunType();
		YunModel ym = hyp.getYunModel();
		// ѺѺ´
		if (yaYunType.equals("Ѻ")) {
			// ãֱУԡ
			if (!CoreMethods.isControversialWord(word, getYunType())) {
				String pingZe = CoreMethods.getWordInfo(word, getYunType())
						.getPingZe();
				String yunBu = CoreMethods.getWordInfo(word, getYunType())
						.getYunBu();
				// ƽƻϲκһǳ
				if (!ym.getPingZe().equals(pingZe)
						|| !ym.getYunBu().equals(yunBu)) {
					canSave = false;
					String infoString = getInfo() + "ϣ";
					setInfo(infoString);
					jtf.setBackground(Color.RED);
					return false;
				} else {
					canSave = true;
					return true;
				}
			} else {
				WordInfo wi1 = CoreMethods.getWordInfo(word, getYunType());
				WordInfo wi2 = CoreMethods
						.getWordInfo(word + "1", getYunType());
				YunModel ym1 = CoreMethods.getYunModelFromWordInfo(wi1);
				YunModel ym2 = CoreMethods.getYunModelFromWordInfo(wi2);
				// ϢֻһֺʣΪɣԶУΪɵһ
				if (ym1.isSameModel(hyp.getYunModel())
						|| ym2.isSameModel(hyp.getYunModel())) {
					canSave = true;
					return true;
				} else {
					canSave = false;
					setInfo(getInfo() + "ϣ");
					jtf.setBackground(Color.RED);
					return false;
				}
			}
		} else if (yaYunType.equals("Э")) {
			// ãֱУԡ
			if (!CoreMethods.isControversialWord(word, getYunType())) {
				String pingZe = CoreMethods.getWordInfo(word, getYunType())
						.getPingZe();
				String yunBu = CoreMethods.getWordInfo(word, getYunType())
						.getYunBu();
				// ֻϲͬƽƲͬźϣϡ
				if (!ym.getPingZe().equals(pingZe)
						&& ym.getYunBu().equals(yunBu)) {
					canSave = true;
					return true;
				} else {
					canSave = false;
					setInfo(getInfo() + "ϣ");
					jtf.setBackground(Color.RED);
					return false;
				}
			} else {
				WordInfo wi1 = CoreMethods.getWordInfo(word, getYunType());
				WordInfo wi2 = CoreMethods
						.getWordInfo(word + "1", getYunType());
				YunModel ym1 = CoreMethods.getYunModelFromWordInfo(wi1);
				YunModel ym2 = CoreMethods.getYunModelFromWordInfo(wi2);
				// ϢֻһֶӦģ뻻ָģƣΪɣԶУΪɵһ
				if (ym1.isSimilarModel(hyp.getYunModel())
						|| ym2.isSimilarModel(hyp.getYunModel())) {
					canSave = true;
					return true;
				} else {
					canSave = false;
					setInfo(getInfo() + "ϣ");
					jtf.setBackground(Color.RED);
					return false;
				}
			}
		} else {
			throw new UnknownYaYunTypeException("Ѻδ֪");
		}
	}

	/**
	 * ֣һƽԶΪƽӦģһֵƽ֣
	 * ûѡĸӰ쵽һλڵϡ
	 * 
	 * @param word
	 *            String
	 */
	public void setYunModel(String word) {
		if (word.length() != 1) {
			ComponentManager.msgBox("Ƿ峤ȣ");
			return;
		}
		YunModel ym;
		// õ˾Ӧеƽ
		String lastWordPingZe = j.getLastWord();
		try {
			// ƽ飬ǿʹƽƶӦΪ
			if (CoreMethods.isPingZeControversialWord(word, getYunType())) {
				ym = new YunModel();
				WordInfo wi1 = CoreMethods.getWordInfo(word, getYunType());
				WordInfo wi2 = CoreMethods
						.getWordInfo(word + "1", getYunType());
				WordInfo wi = wi1.getPingZe().equals(lastWordPingZe) ? wi1
						: wi2;
				ym.setPingZe(wi.getPingZe());
				ym.setYunBu(wi.getYunBu());
				hyp.setYunModel(ym);
			} else if (CoreMethods.isControversialWord(word, getYunType())) {
				WordInfo wi1 = CoreMethods.getWordInfo(word, getYunType());
				WordInfo wi2 = CoreMethods
						.getWordInfo(word + "1", getYunType());
				YunModel ym1 = CoreMethods.getYunModelFromWordInfo(wi1);
				YunModel ym2 = CoreMethods.getYunModelFromWordInfo(wi2);
				new SelectYunModelDialog(this, ym1, ym2);
			} else {
				ym = new YunModel();
				WordInfo wi = CoreMethods.getWordInfo(word, getYunType());
				ym.setPingZe(wi.getPingZe());
				ym.setYunBu(wi.getYunBu());
				hyp.setYunModel(ym);
			}
			String infoString = getInfo() + "ñλ֣" + word;
			setInfo(infoString);
			infoLabel.setText(info);
		} catch (WordParserErrorException e) {
			ComponentManager.msgBox("ʧܣܽ֡");
		} catch (NotWordException e) {
			ComponentManager.msgBox("ʧܣЧ֡");
		}
	}

	/**
	 * 
	 */
	public void clear() {
		jtf.setText("");
	}

	/**
	 * õϸбõΪʱģҪ任
	 * 
	 * @return ArrayList<YunDetails>
	 */
	public ArrayList<YunDetails> getUseableWordsList() {
		if (hyp.getYunModel() == null) {
			return null;
		}

		useableWordsList = CoreMethods.getCommonableYunDetailssFromYunModel(hyp
				.getYunModel(), getYunType());

		return useableWordsList;
	}

	/**
	 * õп
	 * 
	 * @return String
	 */
	public String getUseAbleWords() {
		StringBuilder sb = new StringBuilder();
		for (YunDetails yd : getUseableWordsList()) {
			sb.append(yd.getContent());
		}
		return sb.toString();
	}

	/**
	 * õһݵһɼ顣
	 * 
	 * @return String
	 */
	public String getLastWord() {
		String index = jtf.getText();
		int i = index.length();
		return index.substring(i - 1, i);
	}

	/**
	 * Lock this HTextField,make it can not be adited.We need this method when
	 * open a ci.
	 */
	public void lockInput() {
		jtf.setEditable(false);
	}

	/**
	 * ôʾ䣬Ͼ䣬ϾźͻзӶ
	 * 
	 * @return String
	 */
	public String getCiJu() {
		String dot = isYunJu ? "\n" : "";
		return jtf.getText() + yunJiaoWordField.getText() + dot;
	}

	/**
	 * õһĶϢ
	 * 
	 * @return String
	 */
	public String getInfo() {
		return info;
	}

	/**
	 * һ仰ĶϢ
	 * 
	 * @param info
	 *            String
	 */
	public void setInfo(String info) {
		this.info = info;
	}

	/**
	 * õ˾Ӧеĳ
	 * 
	 * @return int
	 */
	public int getLength() {
		return length;
	}

	/**
	 * ô˾Ӧеĳ
	 * 
	 * @param length
	 *            int
	 */
	public void setLength(int length) {
		this.length = length;
	}

	/**
	 * õһĴ
	 * 
	 * @return String
	 */
	public String getContent() {
		return content;
	}

	/**
	 * һĴ
	 * 
	 * @param content
	 *            String
	 */
	public void setContent(String content) {
		this.content = content;
	}

	/**
	 * õϻ
	 * 
	 * @return String
	 */
	public String getYunType() {
		return yunType;
	}

	/**
	 * ϻ
	 * 
	 * @param yunType
	 *            String
	 */
	public void setYunType(String yunType) {
		this.yunType = yunType;
	}

	/**
	 * õֵĸ
	 * 
	 * @return int
	 */
	public int getNumOfChuLvWords() {
		return numOfChuLvWords;
	}

	/**
	 * óֵĸ
	 * 
	 * @param numOfChuLvWords
	 *            int
	 */
	public void setNumOfChuLvWords(int numOfChuLvWords) {
		this.numOfChuLvWords = numOfChuLvWords;
	}

	/**
	 * 鿴ǷϾ
	 * 
	 * @return boolean
	 */
	public boolean isYunJu() {
		return isYunJu;
	}

	/**
	 * ǷϾ
	 * 
	 * @param isYunJu
	 *            boolean
	 */
	public void setYunJu(boolean isYunJu) {
		this.isYunJu = isYunJu;
	}
}
