package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import org.hiroyukki.bxp.yun.YunModel;
import org.hiroyukki.tools.ui.ComponentManager;

/**
 * ΪѡģԻ򣬵ûõģʱҪûָԼʹõĸģ塣
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class SelectYunModelDialog extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;
	/**
	 * Ҫѡģеһ
	 */
	private YunModel ym1;
	/**
	 * Ҫѡģеһ
	 */
	private YunModel ym2;

	private JLabel pingZeLabel = new JLabel();
	private JLabel yunBuLabel = new JLabel();
	private JButton OKButton = new JButton("ѡ");
	private JButton cancelButton = new JButton("ȡ");
	private JPanel topLeftPanel = new JPanel();
	private JPanel topRightPanel = new JPanel();
	private JPanel topPanel = new JPanel();
	private JPanel underPanel = new JPanel();
	private ButtonGroup bg = new ButtonGroup();
	private JRadioButton ym1Button = new JRadioButton("ģһ", true);
	private JRadioButton ym2Button = new JRadioButton("ģ");

	/**
	 * 壬ʾʵΪĸ崴ġ
	 */
	private JuPanel jp;

	protected SelectYunModelDialog() {
		init();
	}

	/**
	 * ģ壬Ҫûѡ
	 * 
	 * @param ym1
	 *            YunModel
	 * @param ym2
	 *            YunModel
	 */
	public SelectYunModelDialog(JuPanel jp, YunModel ym1, YunModel ym2) {
		this.jp = jp;
		this.ym1 = ym1;
		this.ym2 = ym2;
		init();
	}

	/**
	 * ʼԻ
	 */
	public void init() {
		setTitle("ѡһģ");
		setLayout(new BorderLayout());
		setSize(200, 150);
		pingZeLabel.setText(ym1.getPingZe());
		yunBuLabel.setText(ym1.getYunBu());
		OKButton.addActionListener(this);
		cancelButton.addActionListener(this);
		ym1Button.addActionListener(this);
		ym2Button.addActionListener(this);
		bg.add(ym1Button);
		bg.add(ym2Button);
		topLeftPanel.setLayout(new GridLayout(2, 1, 5, 5));
		topLeftPanel.add(ym1Button);
		topLeftPanel.add(ym2Button);
		topRightPanel.setLayout(new GridLayout(2, 1, 5, 5));
		topRightPanel.add(yunBuLabel);
		topRightPanel.add(pingZeLabel);
		underPanel.add(OKButton);
		underPanel.add(cancelButton);
		topPanel.setLayout(new BorderLayout());
		topPanel.add(topLeftPanel, BorderLayout.WEST);
		topPanel.add(topRightPanel, BorderLayout.CENTER);
		add(topPanel, BorderLayout.CENTER);
		add(underPanel, BorderLayout.SOUTH);
		ComponentManager.moveToCenter(this);
		setVisible(true);
	}

	/**
	 * ѡһģ
	 * 
	 * @return YunModel
	 */
	public YunModel select() {
		if (ym1Button.isSelected()) {
			return ym1;
		} else {
			return ym2;
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == OKButton) {
			YunModel ym = select();
			jp.hyp.setYunModel(ym);
			this.dispose();
		} else if (e.getSource() == cancelButton) {
			this.dispose();
		} else if (e.getSource() == ym1Button) {
			pingZeLabel.setText(ym1.getPingZe());
			yunBuLabel.setText(ym1.getYunBu());
		} else if (e.getSource() == ym2Button) {
			pingZeLabel.setText(ym2.getPingZe());
			yunBuLabel.setText(ym2.getYunBu());
		}
	}

}
