package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.TitledBorder;

import org.hiroyukki.bxp.ciji.Example;
import org.hiroyukki.bxp.cipu.CiPu;
import org.hiroyukki.bxp.ui.main.MainFrame;
import org.hiroyukki.bxp.ui.main.MainMenuBar;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextArea;

/**
 * չʾ壬ͨĴʵչʾ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class ShowCiPuPanel extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	private JPanel bottomPanel = new JPanel();
	private HTextArea jta = new HTextArea();
	private HTextArea exampleArea = new HTextArea();
	private JScrollPane jsp = new JScrollPane(jta);
	private JButton useCiPuButton = new JButton("˸");
	private JPanel topPanel = new JPanel();
	private JButton viewExampleButton = new JButton("鿴ʾ");
	private CiPu cp;
	private boolean isChange = false;

	/**
	 * ͨ׽
	 * 
	 * @param cp
	 */
	public ShowCiPuPanel(CiPu cp) {
		this.cp = cp;
		init();
	}

	/**
	 * UIʼ
	 */
	public void init() {
		setLayout(new BorderLayout());
		setBorder(new TitledBorder("-" + cp.getCiPaiName() + "-"
				+ cp.getType()));
		jta.setBorder(new TitledBorder(""));
		jta.setEditable(false);
		jta.setText(cp.toString());
		exampleArea.setEditable(false);
		topPanel.setLayout(new BorderLayout());
		topPanel.add(jsp, BorderLayout.CENTER);
		add(topPanel, BorderLayout.CENTER);
		viewExampleButton.addActionListener(this);
		useCiPuButton.addActionListener(this);
		bottomPanel.add(useCiPuButton);
		bottomPanel.add(viewExampleButton);
		add(bottomPanel, BorderLayout.SOUTH);
	}

	/**
	 * ҪʣҪ
	 */
	public void edit() {
		CiEditPanel cep = new CiEditPanel(cp, MainMenuBar.getInstance()
				.getYunType());
		MainFrame.getInstance().center.add(cep, cep.getPanelName());
		MainFrame.getInstance().center.setSelectedComponent(cep);
		MainFrame.getInstance().center.remove(WillTianCiPanel.getInstance());
	}

	/**
	 * ʾʾ
	 */
	public void showExample() {
		String ciPaiName = cp.getCiPaiName();
		String result = Example.getCiFromCiPaiName(ciPaiName, cp.getType());
		if (result == null) {
			ComponentManager.msgBox("δҵʾ");
		} else {
			exampleArea.setText(result);
			if (isChange == false) {
				topPanel.setLayout(new GridLayout(1, 2, 5, 5));
				JPanel jpl = new JPanel();
				jpl.setLayout(new BorderLayout());
				exampleArea.setBorder(new TitledBorder("ʾ"));
				jpl.add(new JScrollPane(exampleArea), BorderLayout.CENTER);
				topPanel.add(jpl);
				validate();
			}
			isChange = true;
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == useCiPuButton) {
			edit();
		} else if (e.getSource() == viewExampleButton) {
			showExample();
		}
	}

}
