package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.hiroyukki.bxp.cipu.CiPai;
import org.hiroyukki.bxp.cipu.CiPaiNameRedirector;
import org.hiroyukki.bxp.cipu.CiPu;
import org.hiroyukki.bxp.cipu.CiPuManager;
import org.hiroyukki.bxp.cipu.CiPuNotFoundException;
import org.hiroyukki.bxp.ui.main.MainPanel;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextField;

/**
 * ʱᵯ壬ûѡҪʲôƵģһƲֹһҪûѡһ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class WillTianCiPanel extends JPanel implements ActionListener,
		MainPanel {

	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public static WillTianCiPanel instance;

	/**
	 * õ
	 * 
	 * @return WillTianCiPanel
	 */
	public static WillTianCiPanel getInstance() {
		if (instance == null) {
			instance = new WillTianCiPanel();
		}
		return instance;
	}

	private JSplitPane center = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
	/**
	 * ѡ׵
	 */
	private JPanel choosePanel = new JPanel();
	/**
	 * 壬չʾδãռſա
	 */
	private JPanel cachePanel;
	/**
	 * гһеĸ
	 */
	private JList ciPuList = new JList();
	private JList ciPaiList = new JList();
	private DefaultListModel ciPuListModel = new DefaultListModel();
	private DefaultListModel ciPaiListModel = new DefaultListModel();

	private JPanel leftTopPanel = new JPanel();
	private JPanel ciPaiPanel = new JPanel();
	private JPanel fieldPanel = new JPanel();
	private JPanel listPanel = new JPanel();
	private JButton showCiPuListButton = new JButton("ȷ");
	private HTextField ciPaiField = new HTextField();

	private String currentCiPai;
	private String currentCiPu;

	public WillTianCiPanel() {
		setLayout(new BorderLayout());
		add(center, BorderLayout.CENTER);

		List<String> list = CiPuManager.getAllCiPai();
		int numOfCiPai = 0;
		for (String str : list) {
			ciPaiListModel.add(numOfCiPai, str);
			numOfCiPai++;
		}
		ciPaiList.setModel(ciPaiListModel);

		ciPuList.addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent e) {
				currentCiPu = (String) ciPuList.getSelectedValue();
				if (currentCiPai != null && currentCiPu != null) {
					CiPu cp = new CiPai(currentCiPai).get(currentCiPu);
					remove(cachePanel);
					cachePanel = new ShowCiPuPanel(cp);
					center.setRightComponent(cachePanel);
					center.setDividerLocation(180);
					validate();
				}
			}
		});

		ciPaiList.addListSelectionListener(new ListSelectionListener() {
			@Override
			public void valueChanged(ListSelectionEvent e) {
				currentCiPai = (String) ciPaiList.getSelectedValue();
				if (currentCiPai != null) {
					ciPaiField.setText(currentCiPai);
					parseCiPai(currentCiPai);
				}
			}
		});
		cachePanel = new JPanel();
		showCiPuListButton.addActionListener(this);
		ciPaiField.addActionListener(this);

		leftTopPanel.setLayout(new GridLayout(2, 1, 5, 5));
		leftTopPanel.add(new JLabel("Ҳֹƣ"));
		ciPaiPanel.setBorder(new TitledBorder("ѡ"));
		ciPaiPanel.setLayout(new BorderLayout());
		ciPaiPanel.add(leftTopPanel, BorderLayout.SOUTH);
		ciPaiPanel.add(new JScrollPane(ciPaiList), BorderLayout.CENTER);
		fieldPanel.setLayout(new BorderLayout());
		fieldPanel.add(ciPaiField, BorderLayout.CENTER);
		fieldPanel.add(showCiPuListButton, BorderLayout.EAST);
		leftTopPanel.add(fieldPanel);

		listPanel.setBorder(new TitledBorder("б"));
		listPanel.setLayout(new BorderLayout());
		listPanel.add(new JScrollPane(ciPuList), BorderLayout.CENTER);
		choosePanel.setLayout(new BorderLayout());
		choosePanel.add(ciPaiPanel, BorderLayout.CENTER);
		choosePanel.add(listPanel, BorderLayout.SOUTH);
		center.setLeftComponent(choosePanel);
		center.setRightComponent(cachePanel);
		center.setOneTouchExpandable(true);
		center.setDividerLocation(180);
		center.setDividerSize(15);
		center.setResizeWeight(0);
	}

	/**
	 * ַнơ
	 * <p>
	 * £<br />
	 * ȽеһֵĽֱӲĴҳɹгдбɹȥ鿴˴Ƿб롰
	 * ļﲢû
	 * Ǵתɡɡ÷ĽɡԵݹķʽеڶֵĲҡʧܣжΪ޴ס
	 * </p>
	 * 
	 * @param str
	 *            String
	 */
	public void parseCiPai(String str) {
		if (str.equals("߾") || str.equals("") || str.equals("")
				|| str.equals("")) {
			ComponentManager.msgBox("ļδҵ");
			return;
		}
		CiPai ciPai = null;

		int i = 0;
		try {
			ciPai = new CiPai(str);
			ciPuListModel.clear();
			for (CiPu ciPu : ciPai.values()) {
				ciPuListModel.add(i, ciPu.getType());
				i++;
			}
			ciPuList.setModel(ciPuListModel);
		} catch (CiPuNotFoundException e) {
			currentCiPai = CiPaiNameRedirector.getSameCiPaiName(currentCiPai);
			if (currentCiPai == null) {
				ComponentManager.msgBox("ļδҵ");
				return;
			}
			parseCiPai(currentCiPai);
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == ciPaiField || e.getSource() == showCiPuListButton) {
			currentCiPai = ciPaiField.getText();
			parseCiPai(currentCiPai);
		}
	}

	@Override
	public boolean canClose() {
		return true;
	}

	@Override
	public String getPanelName() {
		return "ѡ";
	}
}
