package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.border.TitledBorder;

import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.hiroyukki.bxp.cipu.CiPuManager;
import org.hiroyukki.bxp.io.cipu.CiPuWriter;
import org.hiroyukki.bxp.ui.ciji.ShowContentWindow;
import org.hiroyukki.bxp.ui.main.MainPanel;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextField;

/**
 * д塣ûѡһмλϣȻ󴫵£һʳд塣
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class WriteCiPuPanel extends JPanel implements MainPanel, ActionListener {

	private static final long serialVersionUID = 1L;

	private ArrayList<WriteHuanYunPanel> writeHuanYunPanelList = new ArrayList<WriteHuanYunPanel>();

	/**
	 * ־ǷѾˣֹڴй¶
	 */
	private boolean isWorked = false;
	/**
	 * ־Ƿ񱣴
	 */
	private boolean isSave = false;
	/**
	 * ־Ӵ׷ӻǸ
	 */
	private String addType;

	/**
	 * 
	 */
	private HTextField ciPaiNameField = new HTextField(6);
	/**
	 * ־ǵڼ
	 */
	private HTextField ciPuTypeField = new HTextField(6);

	private JSplitPane center = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
	private JPanel leftPanel = new JPanel();
	private JPanel rightPanel = new JPanel();
	private JPanel leftTopPanel = new JPanel();
	private JButton cofirmCiPaiNameButton = new JButton("ȷ");
	private JPanel ciPaiNamePanel = new JPanel();

	private JPanel addOrCoverCiPuPanel = new JPanel();
	private ButtonGroup bg = new ButtonGroup();
	private JRadioButton addCiPuButton = new JRadioButton("׷һ", true);
	private JRadioButton coverCiPuButton = new JRadioButton("ԭ");

	private JPanel leftBottomPanel = new JPanel();
	/**
	 * жһмλ
	 */
	private HTextField numOfHuanYunField = new HTextField(6);
	private JButton confirmHuanYunButton = new JButton("ȷ");
	private JPanel numOfHuanYunPanel = new JPanel();
	private JButton saveCiPuButton = new JButton("");
	private JButton viewCiPuButton = new JButton("Ԥ");
	private JPanel savePanel = new JPanel();
	private JPanel infoPanel = new JPanel();
	/**
	 * 
	 */
	private JLabel ciPaiLabel = new JLabel(" ");
	/**
	 * ڼ
	 */
	private JLabel typeLabel = new JLabel(" ");

	public WriteCiPuPanel() {

		cofirmCiPaiNameButton.addActionListener(this);
		ciPaiNameField.addActionListener(this);
		addCiPuButton.addActionListener(this);
		coverCiPuButton.addActionListener(this);
		confirmHuanYunButton.addActionListener(this);
		numOfHuanYunField.addActionListener(this);
		ciPuTypeField.addActionListener(this);
		viewCiPuButton.addActionListener(this);
		saveCiPuButton.addActionListener(this);

		setAddType("add");
		ciPaiNameField.setText("");
		ciPuTypeField.setText("һ");
		numOfHuanYunField.setText("1");

		bg.add(addCiPuButton);
		bg.add(coverCiPuButton);
		addOrCoverCiPuPanel.setLayout(new GridLayout(4, 1, 0, 0));
		addOrCoverCiPuPanel.add(new JLabel("  Ѵڴף룺"));
		addOrCoverCiPuPanel.add(addCiPuButton);
		addOrCoverCiPuPanel.add(coverCiPuButton);
		addOrCoverCiPuPanel.add(ciPuTypeField);

		ciPaiNamePanel.add(ciPaiNameField);
		ciPaiNamePanel.add(cofirmCiPaiNameButton);
		leftTopPanel.setBorder(new TitledBorder("Ϣ"));
		leftTopPanel.setLayout(new BorderLayout());
		leftTopPanel.add(ciPaiNamePanel, BorderLayout.NORTH);

		numOfHuanYunPanel.add(numOfHuanYunField);
		numOfHuanYunPanel.add(confirmHuanYunButton);
		leftBottomPanel.setBorder(new TitledBorder("ײ"));
		leftBottomPanel.setLayout(new BorderLayout());
		leftBottomPanel.add(new JLabel("    ׵Ļϴ"), BorderLayout.NORTH);
		leftBottomPanel.add(numOfHuanYunPanel, BorderLayout.CENTER);
		infoPanel.setLayout(new GridLayout(3, 1, 5, 5));
		savePanel.add(viewCiPuButton);
		savePanel.add(saveCiPuButton);
		infoPanel.add(ciPaiLabel);
		infoPanel.add(typeLabel);
		infoPanel.add(savePanel);
		leftBottomPanel.add(infoPanel, BorderLayout.SOUTH);

		leftPanel.setLayout(new BorderLayout());
		leftPanel.add(leftTopPanel, BorderLayout.NORTH);

		setLayout(new BorderLayout());
		add(center, BorderLayout.CENTER);
		center.setDividerLocation(180);
		center.setDividerSize(15);
		center.setOneTouchExpandable(true);
		center.setResizeWeight(0);
		center.setRightComponent(new JScrollPane(rightPanel));
		center.setLeftComponent(leftPanel);
	}

	/**
	 * Ƿڣͬ
	 */
	public void checkCiPaiName() {
		String ciPaiName = ciPaiNameField.getText();
		if ("".equals(ciPaiName) || ciPaiName == null) {
			ComponentManager.msgBox("Ϊգ");
		} else {
			ciPaiLabel.setText("    " + ciPaiName);
			boolean b = CiPuManager.hasCiPu(ciPaiName);
			if (b) {
				leftTopPanel.add(addOrCoverCiPuPanel, BorderLayout.CENTER);
				validate();
			} else {
				leftTopPanel.remove(addOrCoverCiPuPanel);
				validate();
			}
			// ۴ƴ񣬶ҪĶ
			leftPanel.add(leftBottomPanel, BorderLayout.CENTER);
			validate();
		}
	}

	/**
	 * ȷϼλϺʾ
	 */
	public void confirmHuanYun() {
		if (isWorked == false) {
			try {
				int i = Integer.parseInt(numOfHuanYunField.getText());
				if (i > 20) {
					if (JOptionPane.YES_OPTION != JOptionPane
							.showConfirmDialog(null, "ϴɶ\nȷ")) {
						return;
					}
				}
				rightPanel.setLayout(new GridLayout(i, 1, 0, 0));
				for (int j = 0; j < i; j++) {
					writeHuanYunPanelList.add(new WriteHuanYunPanel());
				}
				for (WriteHuanYunPanel why : writeHuanYunPanelList) {
					rightPanel.add(new JScrollPane(why));
				}
				validate();
				isWorked = true;
			} catch (NumberFormatException e) {
				ComponentManager.msgBox("Ϸ");
			}
		} else {
			ComponentManager
					.msgBox("ֻһλȷϴмλϣ\n\nرմ岢´һд塣");
		}
	}

	/**
	 * һдõһElement
	 * 
	 * @return Element
	 */
	@SuppressWarnings("deprecation")
	public Element getElementByCiPuPanel() {
		Element e = DocumentHelper.createElement("cipu");
		e.setAttributeValue("type", ciPuTypeField.getText());
		for (WriteHuanYunPanel wyp : writeHuanYunPanelList) {
			e.add(wyp.getElementByHuanYunPanel());
		}
		return e;
	}

	/**
	 * ٱ`
	 */
	public void destroy() {
		try {
			this.finalize();
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}

	/**
	 * Ԥ
	 */
	public void viewCiPu() {
		ShowContentWindow.getInstance().showContent(this.toString());
		ShowContentWindow.getInstance().setVisible(true);
	}

	/**
	 * д
	 */
	public void writeCiPu() {
		if (isSave()) {
			ComponentManager.msgBox("Ѿˣ벻Ҫظ棡");
		} else {
			CiPuWriter.writeCiPu(ciPaiNameField.getText(),
					getElementByCiPuPanel(), getAddType());
			setSave(true);
			ComponentManager.msgBox("ɹ");
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == cofirmCiPaiNameButton) {
			checkCiPaiName();
		} else if (e.getSource() == ciPaiNameField) {
			checkCiPaiName();
		} else if (e.getSource() == addCiPuButton) {
			addOrCoverCiPuPanel.add(ciPuTypeField);
			// üģʽΪ׷
			setAddType("add");
			validate();
		} else if (e.getSource() == coverCiPuButton) {
			addOrCoverCiPuPanel.remove(ciPuTypeField);
			// ü´ģʽΪ
			setAddType("cover");
			validate();
		} else if (e.getSource() == confirmHuanYunButton) {
			confirmHuanYun();
		} else if (e.getSource() == numOfHuanYunField) {
			confirmHuanYun();
		} else if (e.getSource() == ciPuTypeField) {
			typeLabel.setText("    ʸ" + ciPuTypeField.getText());
		} else if (e.getSource() == saveCiPuButton) {
			writeCiPu();
		} else if (e.getSource() == viewCiPuButton) {
			viewCiPu();
		}
	}

	@Override
	public boolean canClose() {
		return isSave();
	}

	@Override
	public String getPanelName() {
		return "";
	}

	/**
	 * 鿴ǷѺδ
	 * 
	 * @return boolean
	 */
	public boolean isSave() {
		return isSave;
	}

	/**
	 * ñǷѱ
	 * 
	 * @param isSave
	 *            boolean
	 */
	public void setSave(boolean isSave) {
		this.isSave = isSave;
	}

	/**
	 * 鿴Ӵ׷ӻǸ
	 * 
	 * @return String
	 */
	public String getAddType() {
		return addType;
	}

	/**
	 * Ӵ׷ӻǸ
	 * 
	 * @param addType
	 *            String
	 */
	public void setAddType(String addType) {
		this.addType = addType;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(ciPaiNameField.getText() + "\n\n");
		for (WriteHuanYunPanel why : writeHuanYunPanelList) {
			sb.append(why + "\n");
		}
		return sb.toString();
	}
}
