package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.TitledBorder;

import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextField;

/**
 * һдеĻ壬ÿһλ϶Ӧһʵ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class WriteHuanYunPanel extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	/**
	 * ־ûǷѾӹ
	 */
	private boolean isWorked = false;

	/**
	 * һжϣбоӦмдʵ
	 */
	private ArrayList<WriteYunPanel> writeYunPanelList = new ArrayList<WriteYunPanel>();

	private HTextField numOfYunField = new HTextField(2);
	private JPanel leftPanel = new JPanel();
	private JPanel rightPanel = new JPanel();
	private JButton confirmButton = new JButton("ȷ");
	private JPanel buttonPanel = new JPanel();

	public WriteHuanYunPanel() {
		confirmButton.addActionListener(this);
		numOfYunField.addActionListener(this);
		setBorder(new TitledBorder("һλ"));
		setLayout(new BorderLayout());
		leftPanel.setLayout(new GridLayout(2, 1, 5, 5));
		leftPanel.add(new JLabel("λм"));
		buttonPanel.add(numOfYunField);
		buttonPanel.add(confirmButton);
		leftPanel.add(buttonPanel);
		add(leftPanel, BorderLayout.WEST);
		add(new JScrollPane(rightPanel), BorderLayout.CENTER);
	}

	/**
	 * ȷϱм
	 */
	public void confirmAddYunPanel() {
		if (isWorked == false) {
			try {
				int i = Integer.parseInt(numOfYunField.getText());
				if (i > 20) {
					if (JOptionPane.YES_OPTION != JOptionPane
							.showConfirmDialog(null,
									"ϴ\nɶȷ")) {
						return;
					}
				}
				rightPanel.setLayout(new GridLayout(i, 1, 0, 0));
				for (int j = 0; j < i; j++) {
					writeYunPanelList.add(new WriteYunPanel());
				}
				for (WriteYunPanel wyp : writeYunPanelList) {
					rightPanel.add(new JScrollPane(wyp));
				}
				validate();
				isWorked = true;
			} catch (NumberFormatException e) {
				ComponentManager.msgBox("Ϸ");
			}
		} else {
			ComponentManager
					.msgBox("ֻһλȷϴ˴λмϣ\n\nرմ岢´һд塣");
		}
	}

	/**
	 * дݹElement
	 * 
	 * @return Element
	 */
	public Element getElementByHuanYunPanel() {
		Element e = DocumentHelper.createElement("huanyun");
		for (WriteYunPanel wyp : writeYunPanelList) {
			e.add(wyp.getElementByYunPanel());
		}
		return e;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == numOfYunField || e.getSource() == confirmButton) {
			confirmAddYunPanel();
		}
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		for (WriteYunPanel wyp : writeYunPanelList) {
			sb.append(wyp);
		}
		return sb.toString();
	}
}
