package org.hiroyukki.bxp.ui.cipu;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.TitledBorder;

import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.hiroyukki.tools.ui.ComponentManager;
import org.hiroyukki.tools.ui.HTextField;

/**
 * Ŵеһϣÿһ϶ӦöӦűһʵ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class WriteYunPanel extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	private boolean isWorked = false;

	private ArrayList<WriteJuPanel> writeJuPanelList = new ArrayList<WriteJuPanel>();

	private JComboBox yaYunType = new JComboBox(new String[] { "Ѻ", "Э" });
	private HTextField numOfJuField = new HTextField(2);
	private JButton confirmButton = new JButton("ȷ");
	private JPanel comboBoxPanel = new JPanel();
	private JPanel buttonPanel = new JPanel();
	private JPanel leftPanel = new JPanel();
	private JPanel rightPanel = new JPanel();

	public WriteYunPanel() {
		confirmButton.addActionListener(this);
		numOfJuField.addActionListener(this);
		buttonPanel.add(numOfJuField);
		buttonPanel.add(confirmButton);
		leftPanel.setLayout(new GridLayout(3, 1, 0, 0));
		comboBoxPanel.add(new JLabel("Ѻͣ"));
		comboBoxPanel.add(yaYunType);
		leftPanel.add(new JLabel("뱾м"));
		leftPanel.add(buttonPanel);
		leftPanel.add(comboBoxPanel);
		setBorder(new TitledBorder("һ"));
		yaYunType.setSelectedItem("Ѻ");
		setLayout(new BorderLayout());
		add(leftPanel, BorderLayout.WEST);
		add(new JScrollPane(rightPanel), BorderLayout.CENTER);
	}

	/**
	 * ȷӼдػ
	 */
	public void confirmAddJuPanel() {
		if (isWorked == false) {
			try {
				int i = Integer.parseInt(numOfJuField.getText());
				if (i > 20) {
					if (JOptionPane.YES_OPTION != JOptionPane
							.showConfirmDialog(null,
									"ľֹ\nɶȷ")) {
						return;
					}
				}
				rightPanel.setLayout(new GridLayout(i, 1, 0, 0));
				for (int j = 0; j < i; j++) {
					writeJuPanelList.add(new WriteJuPanel());
				}
				for (WriteJuPanel wjp : writeJuPanelList) {
					rightPanel.add(new JScrollPane(wjp));
				}
				validate();
				isWorked = true;
			} catch (NumberFormatException e) {
				ComponentManager.msgBox("Ϸ");
			}
		} else {
			ComponentManager
					.msgBox("ֻһλȷϴм䣬\n\nرմ岢´һд塣");
		}
	}

	/**
	 * һдϵйһElement
	 * 
	 * @return Element
	 */
	@SuppressWarnings("deprecation")
	public Element getElementByYunPanel() {
		Element e = DocumentHelper.createElement("yun");
		e.setAttributeValue("type", getYaYunType());
		for (WriteJuPanel wjp : writeJuPanelList) {
			e.add(wjp.getElementByJuPanel());
		}
		return e;
	}

	/**
	 * get yaYunType from JComboBox
	 * 
	 * @return String
	 */
	public String getYaYunType() {
		if (yaYunType.getSelectedItem().equals("Ѻ")) {
			return "Ѻ";
		}
		return "Э";
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == numOfJuField || e.getSource() == confirmButton) {
			confirmAddJuPanel();
		}
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		int size = writeJuPanelList.size();
		for (int i = 0; i < size; i++) {
			if (i < writeJuPanelList.size() - 1) {
				sb.append(writeJuPanelList.get(i) + "");
			} else {
				sb.append(writeJuPanelList.get(i) + "");
			}
		}
		sb.append("\n");
		return sb.toString();
	}
}
