package org.hiroyukki.bxp.ui.load;

import org.hiroyukki.bxp.ui.main.MainFrame;
import org.hiroyukki.bxp.ui.tray.FlashTray;
import org.hiroyukki.bxp.ui.tray.MainTray;
import org.hiroyukki.bxp.ui.tray.TrayStock;
import org.hiroyukki.bxp.ui.tray.WelcomeTray;

/**
 * The event maches load UI
 * 
 * @author hiroyukki
 * @since 1.2
 */
public class LoadUI implements LoadEvent {

	public static LoadUI instance;

	@Override
	public String getMessage() {
		return "û...";
	}

	@Override
	public void run() {
		MainTray.getInstance();
		MainFrame.getInstance();
		new Thread(FlashTray.getInstance()).start();
		TrayStock.getInstance().add(new WelcomeTray("about.png"));
	}

	public static LoadEvent getInstance() {
		if (instance == null) {
			instance = new LoadUI();
		}
		return instance;
	}
}
