package org.hiroyukki.bxp.ui.main;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.border.TitledBorder;

import org.hiroyukki.bxp.attention.Attention;
import org.hiroyukki.bxp.desktop.DesktopManager;
import org.hiroyukki.tools.ui.HTextArea;

/**
 * Ǿ̬ģһЩʹñҪ˽ĶͱһЩע
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class HelpPanel extends JPanel implements MainPanel, ActionListener {

	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public static HelpPanel instance;

	/**
	 * õ
	 * 
	 * @return HelpPanel
	 */
	public static HelpPanel getInstance() {
		if (instance == null) {
			instance = new HelpPanel();
		}
		return instance;
	}

	private JTabbedPane center = new JTabbedPane(JTabbedPane.RIGHT);
	private JPanel topPanel = new JPanel();
	private JPanel conceptPanel = new JPanel();
	private JPanel attentionPanel = new JPanel();
	private JPanel aboutBugPanel = new JPanel();
	private JPanel buttonPanel = new JPanel();
	private JButton closeButton = new JButton("رմ");
	private JButton authorButton = new JButton("");

	public HelpPanel() {
		closeButton.addActionListener(this);
		initConceptPanel();
		initAttentionPanel();
		initAboutPanel();

		setLayout(new BorderLayout());
		center.add(new JScrollPane(conceptPanel), "");
		center.add(new JScrollPane(attentionPanel), "һЩ");
		center.add(aboutBugPanel, "BUG");
		topPanel.setBorder(new TitledBorder(""));
		topPanel.setLayout(new BorderLayout());
		topPanel.add(center, BorderLayout.CENTER);
		buttonPanel.setBorder(new TitledBorder(""));
		buttonPanel.add(closeButton);
		add(topPanel, BorderLayout.CENTER);
		add(buttonPanel, BorderLayout.SOUTH);
	}

	// ʼ
	public void initConceptPanel() {
		// 
		HTextArea controversialWordArea = new HTextArea();
		HTextArea pingZeControversialWordArea = new HTextArea();
		HTextArea yunModelArea = new HTextArea();

		controversialWordArea.setLineWrap(true);
		pingZeControversialWordArea.setLineWrap(true);
		yunModelArea.setLineWrap(true);

		controversialWordArea.setText(Attention.CONTROVERIALWORD);
		pingZeControversialWordArea.setText(Attention.PINGZECONTROVERIALWORD);
		yunModelArea.setText(Attention.YUNMODEL);

		controversialWordArea.setEditable(false);
		pingZeControversialWordArea.setEditable(false);
		yunModelArea.setEditable(false);

		conceptPanel.setLayout(new GridLayout(3, 1, 10, 10));
		JPanel controversialWordPanel = new JPanel();
		JPanel pingZeControversialWordPanel = new JPanel();
		JPanel yunModelPanel = new JPanel();
		controversialWordPanel.setLayout(new BorderLayout());
		pingZeControversialWordPanel.setLayout(new BorderLayout());
		yunModelPanel.setLayout(new BorderLayout());

		controversialWordPanel.setBorder(new TitledBorder(""));
		controversialWordPanel.add(new JScrollPane(controversialWordArea),
				BorderLayout.CENTER);
		pingZeControversialWordPanel.setBorder(new TitledBorder("ƽ"));
		pingZeControversialWordPanel.add(new JScrollPane(
				pingZeControversialWordArea));
		yunModelPanel.setBorder(new TitledBorder("ģ"));
		yunModelPanel.add(new JScrollPane(yunModelArea), BorderLayout.CENTER);

		conceptPanel.add(controversialWordPanel);
		conceptPanel.add(pingZeControversialWordPanel);
		conceptPanel.add(yunModelPanel);
	}

	// ʼע
	public void initAttentionPanel() {
		attentionPanel.setLayout(new GridLayout(12, 1, 5, 5));
		attentionPanel.add(new JLabel(Attention.ATTENTION1));
		attentionPanel.add(new JLabel(Attention.ATTENTION2));
		attentionPanel.add(new JLabel(Attention.ATTENTIONb));
		attentionPanel.add(new JLabel(Attention.ATTENTION3));
		attentionPanel.add(new JLabel(Attention.ATTENTION4));
		attentionPanel.add(new JLabel(Attention.ATTENTION5));
		attentionPanel.add(new JLabel(Attention.ATTENTION6));
		attentionPanel.add(new JLabel(Attention.ATTENTION7));
		attentionPanel.add(new JLabel(Attention.ATTENTION8));
		attentionPanel.add(new JLabel(Attention.ATTENTION9));
		attentionPanel.add(new JLabel(Attention.ATTENTIONa));
		attentionPanel.add(new JLabel(Attention.ATTENTIONc));

	}

	// ʼBUG
	public void initAboutPanel() {
		authorButton.addActionListener(this);
		aboutBugPanel.setLayout(new BorderLayout());
		HTextArea bugArea = new HTextArea();
		JPanel jp = new JPanel();
		bugArea.setEditable(false);
		bugArea.setLineWrap(true);
		bugArea.setText(Attention.ABOUTBUG);
		jp.add(authorButton);
		aboutBugPanel.add(new JLabel("BUG"), BorderLayout.NORTH);
		aboutBugPanel.add(new JScrollPane(bugArea), BorderLayout.CENTER);
		aboutBugPanel.add(jp, BorderLayout.SOUTH);
	}

	@Override
	public boolean canClose() {
		return true;
	}

	@Override
	public String getPanelName() {
		return "";
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == closeButton) {
			MainFrame.getInstance().center.remove(HelpPanel.getInstance());
		} else if (e.getSource() == authorButton) {
			DesktopManager
					.browse("http://hi.baidu.com/%B8%D8%C1%D1%D5%DF%B0%C2%CB%B9%C0%EF%B0%B2/board");
		}
	}

}
