package org.hiroyukki.bxp.ui.main;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTabbedPane;

import org.hiroyukki.bxp.cipu.CiPaiNameRedirector;
import org.hiroyukki.bxp.config.ConfigReader;
import org.hiroyukki.bxp.config.ConfigWriter;
import org.hiroyukki.bxp.ui.tray.MainTray;
import org.hiroyukki.tools.ui.img.ImageLoader;
import org.hiroyukki.tools.ui.ComponentManager;

/**
 * 
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class MainFrame extends JFrame implements WindowFocusListener {

	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public static MainFrame instance;

	/**
	 * õ嵥
	 * 
	 * @return MainFrame
	 */
	public static MainFrame getInstance() {
		if (instance == null) {
			instance = new MainFrame();
		}
		return instance;
	}

	public JTabbedPane center = new JTabbedPane();

	public MainFrame() {

		setTitle("2010");
		setIconImage(ImageLoader.getImage("logo.png"));
		setJMenuBar(MainMenuBar.getInstance());
		setLayout(new BorderLayout());
		add(MainToolBar.getInstance(), BorderLayout.NORTH);
		add(center, BorderLayout.CENTER);
		setSize(800, 600);

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent arg0) {
				handleClose();
			}
		});
		if (ConfigReader.getInstance().isHasWelcomePanel() == true) {
			WelcomePanel wp = WelcomePanel.getInstance();
			center.add(wp, wp.getPanelName());
		}
		addWindowFocusListener(this);
		ComponentManager.moveToCenter(this);
	}

	/**
	 * ڹر
	 */
	public void handleClose() {
		if (ConfigReader.getInstance().isExitWhenClose() == true) {
			handleExit();
		} else {
			MainFrame.getInstance().setVisible(false);
			MainTray.getInstance().displayMessage();
		}
	}

	/**
	 * ˳ ˳ʱӦдļʹƶļ
	 */
	public void handleExit() {
		if (closeAllPanel()) {
			ConfigWriter.saveConfig();
			CiPaiNameRedirector.writeOutProperties();
			System.exit(0);
			/**
			 * if (!MainFrame.getInstance().isVisible()) { System.exit(0);
			 * return; } MainFrame.getInstance().setVisible(true);
			 * 
			 * new Thread(new Runnable() {
			 * 
			 * @Override public void run() { int opacity =
			 *           ConfigReader.getInstance().getOpacity(); for (int i =
			 *           opacity; i >= 0; i -= 5) {
			 *           MainFrame.getInstance().setVisible(true);
			 *           AWTUtilities.setWindowOpacity(MainFrame.getInstance(),
			 *           (float) (((float) i) / 100)); try { Thread.sleep(1); }
			 *           catch (InterruptedException e) { e.printStackTrace(); }
			 *           } System.exit(0); } }).start();
			 */
		} else {
			MainFrame.getInstance().setVisible(true);
		}
	}

	/**
	 * close all panels has be open
	 * 
	 * @return boolean if close all panels successful, return ture, else return
	 *         false;
	 */
	private boolean closeAllPanel() {
		for (Component mp : center.getComponents()) {
			if (mp instanceof MainPanel) {
				if (((MainPanel) mp).canClose()) {
					center.remove(mp);
				} else {
					if (JOptionPane.YES_OPTION == JOptionPane
							.showConfirmDialog(null, "ĹûɣȷϹر")) {
						center.remove(mp);
					} else {
						return false;
					}
				}
			}
		}
		return true;
	}

	@Override
	public void windowGainedFocus(WindowEvent e) {
		ComponentManager.fadeOut(this);
	}

	@Override
	public void windowLostFocus(WindowEvent e) {
		ComponentManager.fadeIn(this);
	}
}
