package org.hiroyukki.bxp.ui.main;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JToolBar;

import org.hiroyukki.bxp.desktop.DesktopManager;
import org.hiroyukki.bxp.ui.ciji.CiJiPanel;
import org.hiroyukki.bxp.ui.cipu.WillTianCiPanel;
import org.hiroyukki.bxp.ui.cipu.WriteCiPuPanel;
import org.hiroyukki.bxp.ui.config.ConfigPanel;
import org.hiroyukki.bxp.ui.poem.MakePoemPanel;
import org.hiroyukki.bxp.ui.poem.ShiJiPanel;
import org.hiroyukki.bxp.ui.yun.ShowYunPanel;
import org.hiroyukki.tools.ui.img.*;
import org.hiroyukki.tools.ui.HButton;

/**
 * Ŀ¼
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class MainToolBar extends JToolBar implements ActionListener {

	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public static MainToolBar instance;

	/**
	 * õ
	 * 
	 * @return MainToolBar
	 */
	public static MainToolBar getInstance() {
		if (instance == null) {
			instance = new MainToolBar();
		}
		return instance;
	}

	private HButton writeCiBtn = new HButton(IconLoader
			.getImageIcon("writeCi.png"), "");
	private HButton writeShiBtn = new HButton(IconLoader
			.getImageIcon("writeShi.png"), "ʫ");
	private HButton viewCiJiBtn = new HButton(IconLoader
			.getImageIcon("openCi.png"), "򿪴ʼ");
	private HButton viewShiJiBtn = new HButton(IconLoader
			.getImageIcon("openShi.png"), "ʫ");
	private HButton writeCiPuBtn = new HButton(IconLoader
			.getImageIcon("write.png"), "д");
	private HButton configBtn = new HButton(IconLoader
			.getImageIcon("config.png"), "");
	private HButton closeCurrentBtn = new HButton(IconLoader
			.getImageIcon("close.png"), "رյǰ");
	private HButton viewYunBtn = new HButton(IconLoader
			.getImageIcon("view.png"), "鿴");
	private HButton postBtn = new HButton(IconLoader.getImageIcon("post.png"),
			"ٶδʰ");

	public MainToolBar() {
		writeCiBtn.addActionListener(this);
		writeShiBtn.addActionListener(this);
		writeCiPuBtn.addActionListener(this);
		configBtn.addActionListener(this);
		closeCurrentBtn.addActionListener(this);
		viewYunBtn.addActionListener(this);
		postBtn.addActionListener(this);
		viewCiJiBtn.addActionListener(this);
		viewShiJiBtn.addActionListener(this);

		add(writeCiBtn);
		add(writeShiBtn);
		add(viewCiJiBtn);
		add(viewShiJiBtn);
		addSeparator();
		add(writeCiPuBtn);
		add(viewYunBtn);
		add(configBtn);
		add(closeCurrentBtn);
		addSeparator();
		add(postBtn);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == writeCiBtn) {
			MainMenuBar.getInstance()
					.handlePanel(WillTianCiPanel.getInstance());
		} else if (e.getSource() == writeShiBtn) {
			MainMenuBar.getInstance().handlePanel(new MakePoemPanel());
		} else if (e.getSource() == writeCiPuBtn) {
			MainMenuBar.getInstance().handlePanel(new WriteCiPuPanel());
		} else if (e.getSource() == configBtn) {
			MainMenuBar.getInstance().handlePanel(ConfigPanel.getInstance());
		} else if (e.getSource() == closeCurrentBtn) {
			MainMenuBar.getInstance().handleClosePanel();
		} else if (e.getSource() == viewYunBtn) {
			MainMenuBar.getInstance().handlePanel(ShowYunPanel.getInstance());
		} else if (e.getSource() == postBtn) {
			DesktopManager
					.browse("http://tieba.baidu.com/f?ct=&tn=&rn=&pn=&lm=&cm=0"
							+ "&kw=%CB%CE%B4%CA&rs2=0&sc=&un=&rs1=&rs5=&sn=&rs6=&myselectvalue=0&word=%CB%CE%B4%CA&tb=on");
		} else if (e.getSource() == viewCiJiBtn) {
			MainMenuBar.getInstance().handlePanel(CiJiPanel.getInstance());
		} else if (e.getSource() == viewShiJiBtn) {
			MainMenuBar.getInstance().handlePanel(ShiJiPanel.getInstance());
		}
	}
}
