package org.hiroyukki.bxp.ui.tray;

/**
 * Flash tray.
 * 
 * @author hiroyukki
 * @since 1.2
 */
public class FlashTray implements Runnable {

	public static FlashTray instance;

	public static FlashTray getInstance() {
		if (instance == null) {
			instance = new FlashTray();
		}
		return instance;
	}

	private MainTray tray;
	public boolean isBlink = false;

	private FlashTray() {
		this.tray = MainTray.getInstance();
	}

	@Override
	public void run() {
		boolean b = true;
		while (true) {
			if (isBlink) {
				if (b) {
					tray.trayIcon.setImage(tray.trayImage2);
					b = false;
				} else {
					TrayEvent te = TrayStock.getInstance().get();
					tray.trayIcon.setImage(te.img);
					b = true;
				}
			} else {
				tray.trayIcon.setImage(tray.trayImage1);
			}
			try {
				Thread.sleep(400);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
}
