package org.hiroyukki.bxp.ui.tray;

import java.awt.AWTException;
import java.awt.Image;
import java.awt.Point;
import java.awt.SystemTray;
import java.awt.TrayIcon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JWindow;

import org.hiroyukki.bxp.ui.load.FadeOutThread;
import org.hiroyukki.bxp.ui.main.MainFrame;
import org.hiroyukki.tools.ui.img.*;

/**
 * ϵͳ̡
 * 
 * @author hiroyukki
 * @since 1.0
 **/
public class MainTray implements ActionListener, MouseListener {

	private static MainTray instance;

	private MainTray() {
		init();
	}

	public static MainTray getInstance() {
		if (instance == null) {
			instance = new MainTray();
		}
		return instance;
	}

	public SystemTray systemTray;
	public Image trayImage1 = ImageLoader.getImage("logo.png");
	public Image trayImage2 = ImageLoader.getImage("blink.bng");
	public TrayIcon trayIcon = new TrayIcon(trayImage1, "");
	private JPopupMenu menu = new JPopupMenu();
	private JMenuItem exitItem = new JMenuItem("˳ ", IconLoader
			.getImageIcon("exit.png"));
	private JWindow window = new JWindow();

	private void init() {
		menu.add(exitItem);
		exitItem.addActionListener(this);

		systemTray = SystemTray.getSystemTray();
		try {
			systemTray.add(trayIcon);
		} catch (AWTException e) {
			e.printStackTrace();
		}
		trayIcon.setImageAutoSize(true);
		trayIcon.addActionListener(this);
		trayIcon.addMouseListener(this);
		trayIcon.setToolTip("");

		window.setLocation(-1, -1);
		window.setSize(1, 1);
		window.setVisible(true);
	}

	/**
	 * display message on the trayIcon
	 */
	public void displayMessage() {
		trayIcon.displayMessage("", "汻أ˫ϵͳͼ򿪡",
				TrayIcon.MessageType.INFO);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == exitItem) {
			MainFrame.getInstance().handleExit();
		}
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON3) {
			if (e.getClickCount() == 1) {
				Point point = e.getLocationOnScreen();
				int x = point.x;
				int y = point.y;
				menu.show(window, x, y);
			}
		}
		if (e.getButton() == MouseEvent.BUTTON1 && e.getClickCount() == 2) {
			if (!MainFrame.getInstance().isVisible()) {
				new Thread(new FadeOutThread()).start();
			}
			TrayStock.getInstance().handle();
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mousePressed(MouseEvent e) {
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}

}