package org.hiroyukki.bxp.ui.tray;

import java.util.ArrayList;
import java.util.List;

import org.hiroyukki.bxp.sound.SoundPlayer;
import org.hiroyukki.bxp.sound.SoundResource;

/**
 * Դͼ˸¼
 * 
 * @author hiroyukki
 * @since 1.2
 */
public class TrayStock {

	public static TrayStock instance;

	public static TrayStock getInstance() {
		if (instance == null) {
			instance = new TrayStock();
		}
		return instance;
	}

	private List<TrayEvent> list;

	private TrayStock() {
		list = new ArrayList<TrayEvent>();
	}

	public void add(TrayEvent te) {
		FlashTray.getInstance().isBlink = true;
		SoundPlayer.getInstance().play(SoundResource.MSG);
		list.add(te);
	}

	/**
	 * ˫ͼʱ¼
	 */
	public void handle() {
		if (list.size() != 0) {
			TrayEvent te = list.get(list.size() - 1);
			list.remove(te);
			if (isEmpty()) {
				FlashTray.getInstance().isBlink = false;
			}
			te.handle();
		}
	}

	/**
	 * õ¼
	 * 
	 * @return TrayEvent
	 */
	public TrayEvent get() {
		return list.get(list.size() - 1);
	}

	/**
	 * if size of list is empty, return true
	 * 
	 * @return boolean
	 */
	public boolean isEmpty() {
		return list.size() == 0;
	}
}
