package org.hiroyukki.bxp.yun;

import java.util.HashMap;
import org.w3c.dom.Element;

/**
 * һϸڵĳ ʵһƽˮϼ¼һֵϢ ȻֱϿĸϲ
 * ڹ췽ﴫ˼¼ϲҪĲΪִЧʣڴʼʱͬʱʼֱ ֿʱִĲǴϻ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class YunDetails extends HashMap<String, String> {

	private static final long serialVersionUID = 1L;

	/**
	 * ־ƽ
	 */
	private String type;
	/**
	 * ӸнõElementһһϸ
	 */
	private Element e;
	/**
	 * ݣһϸﺬе
	 */
	private String content;
	/**
	 * ϸ
	 */
	private String name;
	/**
	 * ϸϸϲ
	 */
	private String parentName;
	/**
	 * ־ϵǴϻл
	 */
	private String yunType;

	/**
	 * ֿ
	 */
	public static HashMap<String, WordInfo> zhengYunWordsMap = new HashMap<String, WordInfo>();
	/**
	 * ֿ
	 */
	public static HashMap<String, WordInfo> xinYunWordsMap = new HashMap<String, WordInfo>();

	protected YunDetails() {

	}

	/**
	 * 죬˸ϲļ¼ֿĳʼ
	 * 
	 * @param parentName
	 *            String
	 * @param type
	 *            String
	 * @param e
	 *            Element
	 */
	public YunDetails(String yunType, String parentName, String type, Element e) {
		this.yunType = yunType;
		this.type = type;
		this.e = e;
		this.content = e.getTextContent();
		this.parentName = parentName;
		this.name = e.getAttribute("name");
		if (yunType.equals("")) {
			initZhengYunWordsMap();
		} else if (yunType.equals("л")) {
			initXinYunWordsMap();
		}
		this.put(name, content);
	}

	/**
	 * ʼֿ⡣ Ӹ1ٴ
	 */
	public void initZhengYunWordsMap() {

		WordInfo wi;
		String str;
		int length = content.length();
		for (int i = 0; i < length; i++) {
			str = content.substring(i, i + 1);
			wi = new WordInfo();
			if (zhengYunWordsMap.get(str) == null) {
				wi.setYunDetails(this.getName());
				wi.setPingZe(this.getType());
				wi.setYunBu(this.getParentName());
				zhengYunWordsMap.put(str, wi);
			} else {
				wi.setPingZe(this.getType());
				wi.setYunDetails(this.getName());
				wi.setYunBu(this.getParentName());
				zhengYunWordsMap.put(str + "1", wi);
			}
		}
	}

	/**
	 * ʼֿ⣬һ¼
	 */
	public void initXinYunWordsMap() {
		WordInfo wi;
		String str;
		int length = content.length();
		for (int i = 0; i < length; i++) {
			str = content.substring(i, i + 1);
			wi = new WordInfo();
			if (xinYunWordsMap.get(str) == null) {
				wi.setYunDetails(this.getName());
				wi.setPingZe(this.getType());
				wi.setYunBu(this.getParentName());
				xinYunWordsMap.put(str, wi);
			} else {
				wi.setPingZe(this.getType());
				wi.setYunDetails(this.getName());
				wi.setYunBu(this.getParentName());
				xinYunWordsMap.put(str + "1", wi);
			}
		}
	}

	/**
	 * õһϸ
	 * 
	 * @return content String
	 */
	public String getContent() {
		return content;
	}

	/**
	 * ϸ
	 * 
	 * @param content
	 *            String
	 */
	public void setContent(String content) {
		this.content = content;
	}

	/**
	 * õϸϵ
	 * 
	 * @return name String
	 */
	public String getName() {
		return name;
	}

	/**
	 * ϸ
	 * 
	 * @param name
	 *            String
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * õ󣬼ϲ
	 * 
	 * @return parentName String
	 */
	public String getParentName() {
		return parentName;
	}

	/**
	 * ø󣬼ϲʵǴӹд
	 * 
	 * @param parentName
	 *            String
	 */
	public void setParentName(String parentName) {
		this.parentName = parentName;
	}

	/**
	 * õthisElement
	 * 
	 * @return e Element
	 */
	public Element getE() {
		return e;
	}

	/**
	 * ùthisElementʵElementǴӹд
	 * 
	 * @param e
	 *            Element
	 */
	public void setE(Element e) {
		this.e = e;
	}

	/**
	 * õϸͣƽ
	 * 
	 * @return type String
	 */
	public String getType() {
		return type;
	}

	/**
	 * ϸƽ
	 * 
	 * @param type
	 *            String
	 */
	public void setType(String type) {
		this.type = type;
	}

	/**
	 * õͣõϻ
	 * 
	 * @return yunType String
	 */
	public String getYunType() {
		return yunType;
	}

	/**
	 * ͣ𿪹thisʱõϻ
	 * 
	 * @param yunType
	 *            String
	 */
	public void setYunType(String yunType) {
		this.yunType = yunType;
	}

	@Override
	public String toString() {
		return content;
	}
}
