package org.hiroyukki.tools.date;

import java.util.Calendar;
import java.util.TimeZone;

/**
 * Provide some userful operation for time.
 * 
 * @author hiroyukki
 * @version 2010.01.07
 */
public class DateManager {
	public static String getCurrentTime() {
		StringBuilder sb = new StringBuilder();
		Calendar cal = Calendar.getInstance();
		TimeZone tz = TimeZone.getTimeZone("Asia/Shanghai");
		cal.setTimeZone(tz);
		cal.setTimeInMillis(System.currentTimeMillis());
		int year = cal.get(Calendar.YEAR);
		int month = cal.get(Calendar.MONTH) + 1;
		int day = cal.get(Calendar.DAY_OF_MONTH);
		int hour = cal.get(Calendar.HOUR_OF_DAY);
		int minute = cal.get(Calendar.MINUTE);
		int second = cal.get(Calendar.SECOND);
		sb.append(year);
		sb.append(".");
		if (month < 10) {
			sb.append("0");
		}
		sb.append(month);
		sb.append(".");
		if (day < 10) {
			sb.append("0");
		}
		sb.append(day);
		sb.append(" ");
		if (hour < 10) {
			sb.append("0");
		}
		sb.append(hour);
		sb.append(":");
		if (minute < 10) {
			sb.append("0");
		}
		sb.append(minute);
		sb.append(":");
		if (second < 10) {
			sb.append("0");
		}
		sb.append(second);
		return sb.toString();
	}

	// public static void main(String[] args) {
	// System.out.println(getCurrentTime());
	// }
}
