package org.hiroyukki.tools.io;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * This class provide some static methods to process file and string.
 * 
 * @author hiroyukki
 * @version 2010.01.08
 */
public class HWriter {

	/**
	 * Write content into specialfic file
	 * 
	 * @param content
	 *            String ,need be write into file
	 * @param f
	 *            File
	 */
	public static void writeToFile(String content, File f) {
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(f));
			bw.write(content);
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Write content into file
	 * 
	 * @param content
	 *            content need be write out
	 * @param fileName
	 *            file name
	 */
	public static void writeToFile(String content, String fileName) {
		File f = new File(fileName);
		writeToFile(content, f);
	}
}
