package org.hiroyukki.tools.ui;

import java.awt.Component;
import java.awt.Toolkit;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import org.hiroyukki.tools.ui.img.*;

/**
 * ΪUIڹʾһڣƶһڵȡ
 * 
 * @author hiroyukki
 * @since 1.0
 */
public class ComponentManager {

	public static final int SCREEN_WIDTH = Toolkit.getDefaultToolkit()
			.getScreenSize().width;
	public static final int SCREEN_HEIGHT = Toolkit.getDefaultToolkit()
			.getScreenSize().height;

	/**
	 * һComponentƵĻ
	 * 
	 * @param cp
	 *            Component
	 */
	public static void moveToCenter(Component cp) {
		int width = cp.getWidth();
		int height = cp.getHeight();
		cp
				.setLocation((SCREEN_WIDTH - width) / 2,
						(SCREEN_HEIGHT - height) / 2);
	}

	/**
	 * Make coponent shake a moment.
	 * 
	 * @param cp
	 *            Component
	 */
	public static void shake(Component cp) {
		int x = cp.getLocation().x;
		int y = cp.getLocation().y;
		for (int i = 0; i < 6; i++) {
			try {
				Thread.sleep(30);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			if (i % 2 == 0) {
				x += 5;
				y += 5;
			} else {
				x -= 5;
				y -= 5;
			}
			cp.setLocation(x, y);
		}
	}

	/**
	 * show a messagebox
	 * 
	 * @param str
	 *            message u need to show
	 */
	public static void msgBox(String str) {
		JOptionPane.showMessageDialog(null, str, "", 1, IconLoader
				.getImageIcon("logo.png"));
	}

	public static void msgBox(String str, ImageIcon icon) {
		JOptionPane.showMessageDialog(null, str, "", 1, icon);
	}

	/**
	 * ЧQQĻϷ
	 * 
	 * @param cp
	 *            Component Ҫ
	 */
	public static void fadeIn(Component cp) {
		int y = cp.getLocation().y;
		if (y <= 0) {
			int x = cp.getLocation().x;
			cp.setLocation(x, 0);
			int height = cp.getSize().height;
			for (int i = 0; i < height - 2; i += 5) {
				cp.setLocation(x, -i);
			}
		}
	}

	/**
	 * Ч
	 * 
	 * @param cp
	 *            Component Ҫ
	 */
	public static void fadeOut(Component cp) {
		int y = cp.getLocation().y;
		if (y < 0) {
			int x = cp.getLocation().x;
			cp.setLocation(x, 0);
			for (int i = y; i <= 0; i += 5) {
				cp.setLocation(x, i);
			}
		}
	}
}
