package org.hiroyukki.tools.ui;

import java.io.File;

import javax.swing.JFileChooser;

/**
 * file chooser we need.<br>
 * When instance of this class construct, we can appoint specialfic suffix
 * 
 * @author hiroyukki
 * @version 2010.01.05
 */
public class HFileChooser extends JFileChooser {

	private static final long serialVersionUID = 1L;

	public HFileChooser() {
		this.setCurrentDirectory(new File("."));
		this.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
	}

	public HFileChooser(String[] strs) {
		this.setCurrentDirectory(new File("."));
		this.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

		for (final String s : strs) {
			this.setFileFilter(new javax.swing.filechooser.FileFilter() {
				@Override
				public boolean accept(File f) {
					return f.getName().toLowerCase().endsWith(s)
							|| f.isDirectory();
				}

				@Override
				public String getDescription() {
					return s + "ļ";
				}
			});
		}
	}
}
