package org.hiroyukki.tools.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.text.JTextComponent;

import org.hiroyukki.tools.ui.img.*;

/**
 * This class provide some operations for all JTextComponent.<br>
 * This class is SINGLETON, before evety JTextComponent use it, this singleton
 * instance msut hold refrence of JTextComponent.
 * 
 * @author hiroyukki
 * @version 2010.01.08
 */
public class HPopupMenu extends JPopupMenu implements ActionListener {

	private static final long serialVersionUID = 1L;

	public static HPopupMenu instance;
	private static final Integer I = 1;

	public static HPopupMenu getInstance() {
		if (instance == null) {
			synchronized (I) {
				if (instance == null) {
					instance = new HPopupMenu();
				}
			}
		}
		return instance;
	}

	private JTextComponent jtc;
	private JMenuItem selectAllItem = new JMenuItem("ȫѡ", IconLoader
			.getImageIcon("selectAll.png"));
	private JMenuItem copyItem = new JMenuItem("", IconLoader
			.getImageIcon("copy.png"));
	private JMenuItem pasteItem = new JMenuItem("ճ", IconLoader
			.getImageIcon("paste.png"));
	private JMenuItem cutItem = new JMenuItem("", IconLoader
			.getImageIcon("cut.png"));
	private JMenuItem clearItem = new JMenuItem("", IconLoader
			.getImageIcon("clear.png"));

	private HPopupMenu() {
		copyItem.addActionListener(this);
		pasteItem.addActionListener(this);
		cutItem.addActionListener(this);
		clearItem.addActionListener(this);
		selectAllItem.addActionListener(this);

		add(selectAllItem);
		addSeparator();
		add(copyItem);
		add(pasteItem);
		add(cutItem);
		addSeparator();
		add(clearItem);
	}

	public JTextComponent getJtc() {
		return jtc;
	}

	public void setJtc(JTextComponent jtc) {
		this.jtc = jtc;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == cutItem) {
			if (jtc.isEditable()) {
				jtc.cut();
			}
		} else if (e.getSource() == copyItem) {
			jtc.copy();
		} else if (e.getSource() == pasteItem) {
			if (jtc.isEditable()) {
				jtc.paste();
			}
		} else if (e.getSource() == clearItem) {
			if (jtc.isEditable()) {
				jtc.setText("");
			}
		} else if (e.getSource() == selectAllItem) {
			jtc.selectAll();
		}
	}
}
