package org.hiroyukki.tools.ui;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JTextArea;
import javax.swing.text.Document;

/**
 * This class is my tool, that already define some important operations for it.
 * 
 * @author hiroyukki
 * @version 2010.01.05
 */
public class HTextArea extends JTextArea implements MouseListener, KeyListener {

	private static final long serialVersionUID = 1L;

	public HTextArea() {
		super();
		init();
	}

	public HTextArea(Document doc) {
		super(doc);
		init();
	}

	public HTextArea(Document doc, String str, int a, int b) {
		super(doc, str, a, b);
		init();
	}

	public HTextArea(int a, int b) {
		super(a, b);
		init();
	}

	public HTextArea(String str) {
		super(str);
		init();
	}

	public HTextArea(String str, int a, int b) {
		super(str, a, b);
		init();
	}

	private void init() {
		addKeyListener(this);
		addMouseListener(this);
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON3) {
			this.requestFocus();
			HPopupMenu.getInstance().setJtc(this);
			HPopupMenu.getInstance().show(this, e.getX(), e.getY());
		}
	}

	@Override
	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_F && e.isControlDown()) {
			HFindDialog.getInstance().setJta(this);
			HFindDialog.getInstance().setVisible(true);
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mousePressed(MouseEvent e) {
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}

	@Override
	public void keyReleased(KeyEvent e) {
	}

	@Override
	public void keyTyped(KeyEvent e) {
	}

}
