package org.hiroyukki.tools.ui;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JTextField;
import javax.swing.text.Document;

/**
 * This class is extends JTextField, add some useful menu to do some operations.
 * 
 * @author hiroyukki
 * @version 2010.01.05
 */
public class HTextField extends JTextField implements MouseListener {

	private static final long serialVersionUID = 1L;

	public HTextField() {
		super();
		init();
	}

	public HTextField(int length) {
		super(length);
		init();
	}

	public HTextField(Document doc, String text, int col) {
		super(doc, text, col);
		init();
	}

	public HTextField(String str) {
		super(str);
		init();
	}

	public HTextField(String str, int col) {
		super(str, col);
		init();
	}

	private void init() {
		addMouseListener(this);
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON3) {
			this.requestFocus();
			HPopupMenu.getInstance().setJtc(this);
			HPopupMenu.getInstance().show(this, e.getX(), e.getY());
		}
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mousePressed(MouseEvent e) {
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}
}
